unit OrphNumMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls, grapheNum, ComCtrls, MPlayer, inifiles,math,
  mmsystem, clipbrd, Spin, ImgList, ToolWin,
  SysInfoCtrls, ShlObj, SHFolder, ShellApi,
  OoMisc, AdPort,  LnsWin32, AwUser, dynamic_bass
  {$IFDEF GTI2} , gti2_dynamique, gti2comp {$ENDIF}
  ;

const
   FreqEchGTS2 = 11025;

type
  Tentree = (eSon,eGTI,eGTS2,eGTI2);
  TcurseurTemps = (curNormal,curDebut,curFin,curDeplace);

  TWaveForm = class(TForm)
    PaintBoxAll: TPaintBox;
    OpenDialog: TOpenDialog;
    Timer1: TTimer;
    ScrollBar: TScrollBar;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    OpenFileBtn: TToolButton;
    ExitBtn: TToolButton;
    VolumeBtn: TToolButton;
    PlayBtn: TToolButton;
    BoucleCB: TCheckBox;
    RecordBtn: TToolButton;
    StopBtn: TToolButton;
    MediaPlayer: TMediaPlayer;
    ToolButton3: TToolButton;
    ToolBar2: TPanel;
    EditDecimal: TLabeledEdit;
    EditBinaire: TLabeledEdit;
    BitsTB: TTrackBar;
    LabelBits: TLabel;
    FechTB: TTrackBar;
    LabelFreq: TLabel;
    StopPlayBtn: TToolButton;
    ToolButton1: TToolButton;
    VoieSerie: TApdComPort;
    Gauge: TProgressBar;
    PlaySousEchBtn: TToolButton;
    OrphyBtn: TToolButton;
    LabelBits0: TLabel;
    LabelFreq0: TLabel;
    AideBtn: TToolButton;
    Temps: TLabel;
    Panel1: TPanel;
    Label1: TLabel;
    tempsCB: TCheckBox;
    Timer2: TTimer;
    AnimBtn: TToolButton;
    OptionsBtn: TToolButton;
    StopLabel: TLabel;
    Splitter1: TSplitter;
    PaintBox: TPaintBox;
    procedure OpenFileBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RecordBtnClick(Sender: TObject);
    procedure MediaPlayerNotify(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure VolumeBtnClick(Sender: TObject);
    procedure BitsCBChange(Sender: TObject);
    procedure ScrollBarChange(Sender: TObject);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StopPlayBtnClick(Sender: TObject);
    procedure TriggerAvailBin(CP: TObject; Count: Word);
    procedure TriggerAvailAsc(CP: TObject; Count: Word);
    procedure LanceAcqGTS2;
    procedure LanceAcqGTI;
  {$IFDEF GTI2}
    procedure LanceAcqGTI2;
  {$ENDIF}
    procedure OrphyBtnClick(Sender: TObject);
    procedure AideBtnClick(Sender: TObject);
    procedure tempsCBClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure AnimBtnClick(Sender: TObject);
    procedure OptionsBtnClick(Sender: TObject);
    procedure PaintBoxAllMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxAllMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBoxAllMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxAllPaint(Sender: TObject);
    private
    graphe,grapheAll : TgrapheSon;
    entree : Tentree;
    FreqEch,FreqEchCarte : LongWord;
    NBits,NbitsCarte : byte;
    Nvoies : byte;
    NbrePoints : longInt; { 32 bits }
    FDeviceID: Word;
    FractionLue : double;
    nomFichierWav,nomFichierSousEch : string;
    stopEnCours : boolean;
    startRecord : TdateTime;
    compteur,compteurMax :integer;
    vecteurSon,vecteurSonSousEch : PvecteurSon;
    NomFichier : String;
    deltat : double; { unit 10 s pour GTS2 }
    ordreProgramme,ordreLance : ansiString;
    ordreProgrammeGTI,ordreLanceGTI,ordreResulGTI : ansiString;
    monocoup : boolean;
    fichierFact : boolean;
    attente : boolean;
    indexOctet : byte;
    NbreCourant : integer;
    ChaineLue : ansiString;
    NlignesLues,NlignesAlire : integer;
    finDeChaine : boolean;
    ValeurMot : pseudoWord;
    NbreAnim,NbreMax : integer;
    MesDocsDir,appDataDir,systemDir : string;
    nomFichierIni : string;
 //  conversion mp3 wav
    cancelOp : boolean;
    percentdone : integer;
    bassOK : boolean;
    curseurT : TcurseurTemps;
    debutPB,finPB : longInt;
    debutSelect,finSelect : longInt;
    debutS,finS : integer;
    Xdeplace : integer;
    procedure OuvreFichier(Nom : string);
    procedure StopLecture;
    procedure CloseMedia;
    procedure TestFreq;
    procedure CalculSousEch;
    Procedure testOrphy;
    procedure DecodeFile(SourceFileName : String;var DestFileName : String);
    procedure SaveWav(NomFic : string;vecteur : PvecteurSon);
    Procedure TraceDebutFin;
    procedure TraceSelect;
    Procedure affecteDebutFin;
  public
  protected
{$IFDEF GTI2}
      procedure WMZresul(var Msg: Tmessage); message WM_Zresul;
      procedure WMFinZresul(var Msg: Tmessage); message WM_Fin_Zresul;
{$ENDIF}
  end;

var
  WaveForm: TWaveForm;

implementation

uses optWavNum;

{$R *.DFM}

const
   ecartDebutFin = 50;
   precDebutFin = 5;

type
   EWavError = class(Exception);

function AddBackSlash(aPath: string): string;
begin
   Result := EmptyStr;
   if (aPath <> '') and (aPath[Length(aPath)] <> '\') then
      Result := aPath + '\';
end;

// permet de retrouver un repertoire d'aprs sa valeur CSIDL
function GetFolder(CSIDLValue: integer): string;
var
   IdList: PITEMIDLIST;
   Folder: array[0..MAX_PATH] of char;
begin
   if not Failed(SHGetSpecialFolderLocation(0, CSIDLValue, IdList)) then
   begin
      SHGetPathFromIDList(IdList, Folder);
      Result := AddBackSlash(Folder);
   end;
end;

function IsPortAvailable(ComNum : Cardinal) : Boolean;

  function MakeComName(const Dest : PChar; const ComNum : Cardinal) : PChar;
    {-Return a string like 'COMXX'}
  begin
    StrFmt(Dest,'\\.\COM%d',[ComNum]);
    MakeComName := Dest;
  end;

var
  ComName : array[0..12] of Char;
  Res : Integer;
  DeviceLayer : TApdBaseDispatcher;
begin
  DeviceLayer  := TApdWin32Dispatcher.Create(nil);
  try
    if ComNum = 0
    then Result := False
    else begin
      Res := DeviceLayer.OpenCom(MakeComName(ComName,ComNum), 64, 64);
      if (Res < 0) and (GetLastError <> DWORD(Abs(ecAccessDenied)))
        then Result := False
        else begin
          Result := True;
          DeviceLayer.CloseCom;
        end;
    end;
  finally
    DeviceLayer.Free;
  end;
end;

procedure TWaveForm.OpenFileBtnClick(Sender: TObject);
var extension,fichierWav : string;
begin
  if OpenDialog.execute then begin
     extension := extractFileExt(openDialog.fileName);
     extension := UpperCase(extension);
     if extension='.MP3'
        then if bassOK
           then begin
              decodeFile(openDialog.fileName,fichierWav);
              ouvrefichier(fichierWav);
           end
           else showMessage('Bass.dll non trouv')
     else ouvreFichier(openDialog.fileName);
  end;
end;

procedure TWaveForm.OuvreFichier(Nom : string);
var Hfichier : integer;

Procedure Test;
var i : integer;
    fichier : TextFile;
    octet : byte;
begin
     FileSeek(Hfichier,0,0);
     AssignFile(fichier,changeFileExt(Nom,'.txt'));
     Rewrite(fichier);
     for i := 0 to 60 do begin
         FileRead(Hfichier,octet,1);
         Writeln(fichier,i,' ',octet,' ',chr(octet));
     end;
     for i := 5852 to 7052 do begin
         Write(fichier,i);
         FileRead(Hfichier,octet,1);
         Write(fichier,' ',octet);
         FileRead(Hfichier,octet,1);
         Write(fichier,' ',octet);
         FileRead(Hfichier,octet,1);
         Write(fichier,' ',octet);
         FileRead(Hfichier,octet,1);
         Writeln(fichier,' ',octet);
     end;
     CloseFile(fichier);
end;

Procedure Erreur;
begin
        NomFichier := '';
        MediaPlayer.Wait := true;
        MediaPlayer.Notify := false;
        try
        MediaPlayer.close;
        except
        end;
        MediaPlayer.FileName := '';
end;

var i : integer;
    codeF : word;
    octet : byte;
    texte : ansiString;
    taille : longInt;
    larg : longInt;
begin // ouvreFichier 
     try
     NomFichier := AnsiUpperCase(Nom);
     if not(FileExists(NomFichier)) then begin
        nomFichier := '';
        exit;
     end;
     Hfichier := FileOpen(NomFichier,fmOpenRead);
     if HFichier<0 then
        raise EWavError.Create('Problme d''ouverture');
//     Test;
     FileSeek(Hfichier,4,0);
     FileRead(Hfichier,taille,4);
     FileSeek(Hfichier,24,0);
     FileRead(Hfichier,codeF,2);
     FreqEch := codeF;
     FileSeek(Hfichier,34,0);
     FileRead(Hfichier,Nbits,1);
     if Nbits=8
        then vecteurSon.formatWave := f8
        else if Nbits=16
             then vecteurSon.formatWave := f16
             else begin
                  FileClose(Hfichier);
                  raise EWavError.Create('erFormatWav');
             end;
     FileSeek(Hfichier,22,0);
     FileRead(Hfichier,Nvoies,1);
     if Nvoies=2 then
        if vecteurSon.formatWave=f8
           then vecteurSon.formatWave := f8stereo
           else vecteurSon.formatWave := f16stereo;
     vecteurSonSousEch.formatWave := vecteurSon.formatWave;
     FileSeek(Hfichier,36,0);
     texte := '    ';
     for i := 1 to 4 do begin
         FileRead(Hfichier,octet,1);
         texte[i] := ansiChar(octet);
     end;
     i := 40;
     FichierFact := false;
     while (i<taille) and (texte<>'data') do begin
          delete(texte,1,1);
          if texte='fact' then FichierFact := true;
          FileRead(Hfichier,octet,1);
          texte := texte+ansiChar(octet);
          inc(i);
     end;
     if i>=taille then begin
         FileClose(Hfichier);
         raise EWavError.Create('Format incorrect');
     end;
     FileRead(Hfichier,NbrePoints,4);
     if NbrePoints>MaxVecteurSon
        then begin
            FractionLue := NbrePoints/MaxVecteurSon;
            NbrePoints := MaxVecteurSon;
        end
        else FractionLue := 1;
     case vecteurSon.formatWave of
        f8 : NbrePoints := FileRead(Hfichier, vecteurSon.son8, NbrePoints);
        f8stereo : begin
           NbrePoints := FileRead(Hfichier, vecteurSon.son8s, NbrePoints);
           NbrePoints := NbrePoints div 2;
        end;
        f16 : begin
            NbrePoints := FileRead(Hfichier, vecteurSon.son16, NbrePoints);
            NbrePoints := NbrePoints div 2;
        end;
        f16stereo : begin
           NbrePoints := FileRead(Hfichier, vecteurSon.son16s, NbrePoints);
           NbrePoints := NbrePoints div 4;
        end;
     end;
     FileClose(Hfichier);
     if NbrePoints<=0 then raise EWavError.Create('');
     if FractionLue<1 then caption := caption + 'erTronque';
     stopLecture;
     MediaPlayer.FileName := NomFichier;
     MediaPlayer.open;
     if not (mediaPlayer.timeFormat in [tfSamples,tfMilliSeconds]) then
        mediaPlayer.timeFormat := tfSamples;
     PlayBtn.enabled := true;
     AnimBtn.enabled := true;
     PlaySousEchBtn.enabled := true;
     BitsTB.Enabled := true;
     FechTB.Enabled := true;
     StopPlayBtn.Enabled := false;
     except
        Erreur
     end;
     graphe.repere := 0;
     graphe.repereTemps := 0;
     graphe.NbreTot := NbrePoints;
     grapheAll.NbreTot := NbrePoints;
     scrollBar.Max := NbrePoints;
     scrollBar.smallChange := 16;
     if paintBox.width>(NbrePoints div 50)
        then larg := paintBox.width
        else larg := NbrePoints div 50;
     scrollBar.largeChange := larg;
     scrollBar.pageSize := larg;
     calculSousEch;
     debutS := 0;
     finS := pred(NbrePoints);
     paintBoxAll.Refresh;
end;// ouvreFichier

procedure TWaveForm.ExitBtnClick(Sender: TObject);
begin
    Close
end;

procedure TWaveForm.FormCreate(Sender: TObject);

Procedure Creation(Nom : string);
var F : TextFile;
begin
     if not FileExists(Nom) then begin
     AssignFile(F,Nom);
     Rewrite(F);
     write(F,'RIFF');
     CloseFile(F);
     end;
end;

Procedure Options;
var fichier : TmemIniFile;
begin
     try
     Fichier := tMemIniFile.create(NomFichierIni);
     try
     CouleurCourbe := Tcolor(Fichier.ReadInteger('Couleur','Courbe',ord(CouleurCourbe)));
     CouleurCourbeBis := Tcolor(Fichier.ReadInteger('Couleur','Bis',ord(CouleurCourbeBis)));
     CouleurNiveau := Tcolor(Fichier.ReadInteger('Couleur','Niveau',ord(CouleurNiveau)));
     finally
     fichier.free;
     end;
     except
     end;
end;

begin
   MesDocsDir := GetFolder(CSIDL_Personal)+'Regressi';
   if not DirectoryExists(MesDocsDir) then
       createDir(MesDocsDir);
   MesDocsDir := addBackSlash(MesDocsDir);
   appDataDir := GetFolder(CSIDL_AppData)+'Regressi';
   if not DirectoryExists(appDataDir) then
       createDir(appDataDir);
   appDataDir := addBackSlash(appDataDir);
   systemDir := GetFolder(CSIDL_SYSTEM);
   systemDir := addBackSlash(systemDir);
   nomFichierIni := appDataDir+'wavnum.ini';
   entree := eSon;
    Gauge.max := FreqEchGTS2;
    new(vecteurSon);
    new(vecteurSonSousEch);
    FichierFact := false;

    graphe := TgrapheSon.create;
    graphe.canvas := PaintBox.canvas;
    graphe.son := vecteurSon;
    graphe.sonBis := vecteurSonSousEch;
    graphe.binaire := EditBinaire;
    graphe.decimal := EditDecimal;
    graphe.labelTemps := Temps;

    grapheAll := TgrapheSon.create;
    grapheAll.canvas := PaintBoxAll.canvas;
    grapheAll.son := vecteurSonSousEch;
    grapheAll.sonBis := vecteurSon;

    NomFichierWav := AppDataDir+'wavnum.wav';
    NomFichierSousEch := AppDataDir+'wavnum0.wav';
    NomFichier := '';
    {$IFDEF GTI2}
    if gti2permis then GTI2 := Tgti2.Create(handle);
    {$ENDIF}
    if FileExists(nomFichierIni) then Options;
    BassOK := Load_BASSDLL('bass.dll');
    try
    if BassOK then
       BASS_Init(-1, 44100, Bass_unicode, Application.Handle, nil);
    except
       BassOK := false;
    end;
    creation(NomFichierSousEch);
    creation(NomFichierWav);
    TestFreq;
end;

procedure TWaveForm.PaintBoxPaint(Sender: TObject);
begin with graphe do begin
        if NomFichier='' then exit;
        NbreBitsInit := Nbits;
        avecTemps := tempsCB.checked;
        rectPB := rect(0,0,paintBox.width,paintBox.height);
        frequence := freqEch;
        decalageCanvas := paintBox.Top;
        LimiteCourbe := PaintBox.ClientRect;
        LabelBits0.caption := '('+IntToStr(Nbits)+' bits)';
        LabelFreq0.caption := '('+IntToStr(FreqEch)+' Hz)';
        drawG;
end end;

procedure TWaveForm.FormDestroy(Sender: TObject);

Procedure Options;
var fichier : TmemIniFile;
begin
     try
     Fichier := tMemIniFile.create(NomFichierIni);
     try
     Fichier.WriteInteger('Couleur','Courbe',ord(CouleurCourbe));
     Fichier.WriteInteger('Couleur','Bis',ord(CouleurCourbeBis));
     Fichier.WriteInteger('Couleur','Niveau',ord(CouleurNiveau));
     Fichier.updateFile;
     finally
     fichier.free;
     end;
     except
     end;
end;

begin
     options;
     graphe.free;
     grapheAll.free;
     dispose(vecteurSon);
     dispose(vecteurSonSousEch);
end;

procedure TWaveForm.FormDeactivate(Sender: TObject);
begin
     try
     MediaPlayer.close
     except
     end;
end;

procedure TWaveForm.FormActivate(Sender: TObject);
begin
   if MediaPlayer.FileName<>'' then MediaPlayer.open
end;

procedure TWaveForm.FormResize(Sender: TObject);
begin
     PaintBox.Height := (ClientHeight-ToolBar2.Height-ToolBar1.Height-ScrollBar.height) div 2;
     scrollBar.largeChange := PaintBox.width;
end;

procedure TWaveForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     stopLecture;
     case entree of
         EGTS2 : begin
            VoieSerie.open := true;
            VoieSerie.output := 'WBAUDS 0'+crCR; // retour  9600 bauds
         end;
         eGTi : begin
            VoieSerie.open := true;
            VoieSerie.output := 'YBAUDS 4'+crCR; // retour  9600 bauds
         end;
         eGTI2 : ; 
     end;
end;

procedure TWaveForm.StopLecture;
begin
        if not PlayBtn.enabled then exit;
        try
        MediaPlayer.Wait := true;
        MediaPlayer.Notify := false;
        MediaPlayer.Stop;
        MediaPlayer.Wait := true;
        Timer1.Enabled := false;
        MediaPlayer.Notify := false;
        MediaPlayer.Close;
        except
        end;
end;

procedure TWaveForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var P : Tpoint;
begin
     GetCursorPos(P);
     case key of
          vk_left : dec(P.X);
          vk_right : inc(P.X);
          vk_down : inc(P.Y);
          vk_up : dec(P.Y);
          vk_prior : if ssShift in shift
              then dec(P.X,10)
              else dec(P.Y,10);
          vk_next : if ssShift in shift
              then inc(P.X,10)
              else inc(P.Y,10);
          vk_delete : ;
          else exit;
     end;
     setCursorPos(P.X,P.Y);
end;

procedure TWaveForm.CloseMedia;
var
    MyGenParms: TMCI_Generic_Parms;
    MyError,Flags : LongInt;
begin
    if FDeviceID <> 0 then begin
      Flags:=0;
      MyGenParms.dwCallback:=Handle; // Form
      MyError:=mciSendCommand(FDeviceID,mci_Close,Flags,LongWord(@MyGenParms));
      if MyError = 0 then FDeviceID:=0;
    end;
end;

procedure TWaveForm.RecordBtnClick(sender : Tobject);

procedure OpenMedia;
var
    MyOpenParms: TMCI_Open_Parms;
    MyWaveParms : TMCI_WAVE_SET_PARMS;
    Flags : longWord;
    MyError : LongInt;
begin
    Flags:=mci_Wait or mci_Open_Element or mci_Open_Type;
    with MyOpenParms do  begin
      dwCallback:=Handle; // Form
      lpstrDeviceType:=PChar('WaveAudio');
      lpstrElementName:=PChar('');
    end;
    MyError:=mciSendCommand(0,mci_Open,Flags,LongWord(@MyOpenParms));
    if MyError = 0 then FDeviceID:=MyOpenParms.wDeviceID;
    with MyWaveParms do begin
          dwCallback := handle;
          nChannels := 1;
          nSamplesPerSec := freqEchCarte;
          FreqEch := FreqEchCarte;
          nAvgBytesPerSec := freqEchCarte*NbitsCarte div 8;
          nBlockAlign := NbitsCarte div 8;
          wBitsPerSample := NbitsCarte;
    end;
    Flags := MCI_WAIT or
             MCI_WAVE_SET_BITSPERSAMPLE or
             MCI_WAVE_SET_CHANNELS or
             MCI_WAVE_SET_SAMPLESPERSEC or
             MCI_WAVE_SET_AVGBYTESPERSEC or
             MCI_WAVE_SET_BLOCKALIGN;
    mciSendCommand(FdeviceId, MCI_SET,Flags,longWord(@MyWaveParms));
end;

procedure RecordMedia;
var
    MyRecordParms: TMCI_Record_Parms;
    Flags : LongInt;
begin
    Flags:=mci_Notify;
    with MyRecordParms do  begin
        dwCallback:=Handle;  // form
        dwFrom:=0;
        dwTo:=0;
    end;
    try
    mciSendCommand(FDeviceID,mci_Record,Flags,LongWord(@MyRecordParms));
    except;
        CloseMedia;
    end;
end;

{
procedure StopMedia;
var
    MyGenParms: TMCI_Generic_Parms;
    Flags : LongInt;
begin
  if FDeviceID <> 0 then  begin
      Flags:=mci_Wait;
      MyGenParms.dwCallback:=Handle;  // Form
      try
      mciSendCommand(FDeviceID,mci_Stop,Flags,LongWord(@MyGenParms));
      except
          CloseMedia;
      end;
    end;
end;
}

Procedure RecordWav;
begin
     OpenMedia;
     RecordMedia;
     startRecord := now;
end;

begin
      NomFichier := '';
      FichierFact := false;
      graphe.repere := 0;
      graphe.repereTemps := 0;
      try
      MediaPlayer.Wait := true;
      MediaPlayer.Notify := false;
      MediaPlayer.close;
      except
      end;
      PlayBtn.enabled := false;
      AnimBtn.enabled := false;      
      PlaySousEchBtn.enabled := false;
      StopBtn.enabled := true;
      RecordBtn.enabled := false;
      stopEnCours := false;
      case entree of
          eGTS2 : LanceAcqGTS2;
          eGTI : LanceAcqGTI;
  {$IFDEF GTI2}
          eGTI2 : LanceAcqGTI2;
  {$ENDIF}
          else recordWav
      end;
end; { record }

procedure TWaveForm.MediaPlayerNotify(Sender: TObject);
begin
 if boucleCB.checked and StopPlayBtn.enabled
     then begin
         mediaPlayer.notify := true;
         mediaPlayer.play;
     end
     else begin
         PlayBtn.enabled := true;
         AnimBtn.enabled := true;
         PlaySousEchBtn.enabled := true;
         StopPlayBtn.Enabled := false;         
         BitsTB.Enabled := true;
         FechTB.Enabled := true;
         Timer1.Enabled := false;
     end;
end;

procedure TWaveForm.PlayBtnClick(Sender: TObject);

Function GetPos(posInt : integer) : LongInt;
begin
   if mediaPlayer.timeFormat=tfMilliseconds
      then result := round(posInt*1000.0/FreqEch)
      else result := posInt;
end;

begin
  if ((sender=playSousEchBtn) and
      (MediaPlayer.FileName=NomFichier)) or
      ((sender=playBtn) and
       (MediaPlayer.FileName=NomFichierSousEch)) then begin
           MediaPlayer.Wait := true;
           MediaPlayer.Notify := false;
           MediaPlayer.Stop;
           try
           MediaPlayer.Close;
           except
           end;
           if sender=playSousEchBtn
              then MediaPlayer.FileName := NomFichierSousEch
              else MediaPlayer.FileName := NomFichier;
           MediaPlayer.Notify := false;
           MediaPlayer.Open;
  end;
  PlayBtn.enabled := false;
  AnimBtn.enabled := false;  
  PlaySousEchBtn.enabled := false;
  BitsTB.Enabled := false;
  FechTB.Enabled := false;
  StopPlayBtn.enabled := true;
  StopBtn.enabled := false;
  MediaPlayer.notify := true;
  MediaPlayer.StartPos := getPos(debutS);
  MediaPlayer.EndPos := getPos(finS);
  Timer1.Enabled := true;
  MediaPlayer.Play;
end;

procedure TWaveForm.Timer1Timer(Sender: TObject);

procedure SaveMedia;
type    // not implemented by Delphi
    TMCI_Save_Parms = record
      dwCallback: DWord;
      lpstrFileName: PChar;  // name of file to save
    end;
var
    MySaveParms: TMCI_Save_Parms;
    Flags : LongInt;
begin
    if FDeviceID <> 0 then  begin
        // save the file...
      Cursor := crDefault;
      Flags:=mci_Save_File or mci_Wait;
      with MySaveParms do begin
          dwCallback:=Handle;
          lpstrFileName:=PChar(NomFichierWav);
      end;
      try
      mciSendCommand(FDeviceID,mci_Save,Flags,LongWord(@MySaveParms));
      closeMedia;
      OuvreFichier(NomFichierWav);
      NomFichier := NomFichierWav;
      except
          NomFichier := '';
      end;
    end;
end;

var posRelative : double;
begin
    if StopEnCours then begin
       inc(compteur);
       if compteur>compteurMax then begin
          stopEnCours := false;
          recordBtn.enabled := true;
          cursor := crDefault;
          Timer1.enabled := false;
          try
          saveMedia;
          except
             NomFichier := '';
          end;
          closeMedia;
          stopLabel.Visible := false;
        end;
    end
    else if MediaPlayer.FileName<>'' then begin
         posRelative := mediaPlayer.position/mediaPlayer.length;
         ScrollBar.Position := round(posRelative*ScrollBar.Max);
    end;
end;

procedure TWaveForm.StopBtnClick(Sender: TObject);
var h,m,s,ms : word;
    dureeSec : double;
begin
      StopBtn.enabled := false;
      stopEnCours := true;
      if entree=eSon
         then begin
            StopLabel.Visible := true;
            decodeTime(now-startRecord,h,m,s,ms);
            DureeSec := m*60.0+s*1.0+ms*0.001;
            CompteurMax := round((1000*DureeSec-trunc(dureeSec))/Timer1.interval)+1;
// On attend la seconde entire qui est l'unit d'enregistrement
            Compteur := 0;
            Timer1.enabled := true;
            cursor := crHourGlass;
         end
         else begin
            cursor := crHourGlass;
            delayTicks(2,false); // entre 55 ms et 110 ms
            Application.processMessages;
            case entree of
               eGTI : voieSerie.Output := 'YHALT'+crCR;
               eGTS2 : voieSerie.Output := 'WPE'+crCR;
{$IFDEF GTI2}
               eGTI2 : begin
                   gti2.Output := 'WPE';
                   gti2.stopThreadZresul(true);
               end;
{$ENDIF}
            end;
      if entree<>eGTI2 then begin
            repeat
               VoieSerie.flushInBuffer;
               Application.processMessages;
 // vide buffer des messages RS232 Windows }
               delayTicks(2,false); // entre 55 ms et 110 ms
               VoieSerie.processCommunications;
             until not VoieSerie.charReady;
             voieSerie.Open := false;
       end;      
             RecordBtn.enabled := true;
             cursor := crDefault;
         end;
end;

procedure TWaveForm.VolumeBtnClick(Sender: TObject);
var ordre : string;
const FinOrdre = 'sndvol32.exe /r';
begin
     ordre := systemDir + finOrdre;
     if ShellExecute(0, 'open', Pchar(ordre), nil, nil, SW_SHOWDEFAULT)< 32 then
        showMessage('Impossible');
     volumeBtn.visible := false;
end;

procedure TWaveForm.TestFreq;
var
   WaveCaps : PWAVEINCAPS;

Function Test(wf,f : longWord;b : integer) : boolean;
begin
     result := (WaveCaps^.dwFormats and WF) = WF;
     if result then begin
           freqEchCarte := f;
           NbitsCarte := b;
           if NbitsCarte=8
              then vecteurSon.formatWave := f8
              else vecteurSon.formatWave := f16;
           vecteurSonSousEch.formatWave := vecteurSon.formatWave;
     end;
end;

var i : integer;
begin // testFreq
     new(waveCaps);
     i := waveInGetDevCaps(0,PwaveInCapsW(WAVECAPS),sizeof(waveIncaps));
     if i<>0 then begin
         showMessage('Pas d''entre son');
         close;
     end;
     freqEchCarte := 0;
     if test(WAVE_FORMAT_1M08,11025,16) or
        test(WAVE_FORMAT_2M16,22050,16) or
        test(WAVE_FORMAT_4M08,44100,16) or
        test(WAVE_FORMAT_1M16,11025,8) or
        test(WAVE_FORMAT_2M08,22050,8) or
        test(WAVE_FORMAT_4M16,44100,8) then ;
     if freqEchCarte=0 then begin
         showMessage('Pas d''entre son utilisable');
         close;
     end;
     dispose(waveCaps);
end;// TestFreq

procedure TWaveForm.CalculSousEch;
var pasF : integer;
    minS,maxS : integer;
    coeffBit : integer;

procedure calc8;
var i,s : integer;
begin
    for i := 0 to pred(NbrePoints) do begin
       s:= coeffBit*(vecteurSon.son8[i-(i mod pasF)] div coeffBit);
//       if s>maxS then maxS := s else if s<minS then minS := s;
       vecteurSonSousEch.son8[i] := s;
    end;
end;

procedure calc8Stereo;
var i,sg,sd : integer;
begin
    for i := 0 to pred(NbrePoints) do begin
       sg := coeffBit*(vecteurSon.son8s[i-(i mod pasF),gauche] div coeffBit);
//       if sg>maxS then maxS := sg else if sg<minS then minS := sg;
       sd := coeffBit*(vecteurSon.son8s[i-(i mod pasF),droite] div coeffBit);
       vecteurSonSousEch.son8s[i,gauche] := sg;
       vecteurSonSousEch.son8s[i,droite] := sd;
    end;
end;

procedure calc16;
var i,s : integer;
    negatif : boolean;
begin
    for i := 0 to pred(NbrePoints) do begin
        s := vecteurSon.son16[i-(i mod pasF)];
        negatif := s<0;
        s := coeffBit*(abs(s) div coeffBit);
        if negatif then s := -s-coeffBit;
//        if s>maxS then maxS := s else if s<minS then minS := s;
        vecteurSonSousEch.son16[i] := s;
    end;
end;

procedure calc16stereo;
var i,sg,sd : integer;
    negatif : boolean;
begin
    for i := 0 to pred(NbrePoints) do begin
       sg := vecteurSon.son16s[i-(i mod pasF),gauche];
       negatif := sg<0;
       sg := coeffBit*(abs(sg) div coeffBit);
       if negatif then sg := -sg-coeffBit;
       sd := vecteurSon.son16s[i-(i mod pasF),droite];
       negatif := sd<0;
       sd := coeffBit*(abs(sd) div coeffBit);
       if negatif then sd := -sd-coeffBit;
//       if sg>maxS then maxS := sg else if sg<minS then minS := sg;
       vecteurSonSousEch.son16s[i,gauche] := sg;
       vecteurSonSousEch.son16s[i,droite] := sd;
    end;
end;

begin // CalculSousEch
     graphe.nbreBits := BitsTB.position;
     coeffBit := round(power(2,Nbits-bitsTB.position));
     labelBits.caption := intToStr(bitsTB.position)+' bits';
     graphe.pasFreq := FechTB.max-FechTB.position+1;
     pasF := graphe.pasFreq;
     labelFreq.caption := intToStr(FreqEch div pasF)+' Hz';
     if vecteurSon.formatWave in [f8,f8stereo]
        then begin
             minS := 0;
             maxS := 256;
        end
        else begin
             minS := -maxSon16;
             maxS := +maxSon16;
        end;
     case vecteurSon.formatWave of
          f8 : calc8;
          f8stereo : calc8stereo;
          f16 : calc16;
          f16stereo : calc16stereo;
     end;
{
     deltaS := (maxS-minS) div 128;
     maxS := maxS+deltaS;
     minS := minS-deltaS;
     if vecteurSon.formatWave in [f8,f8stereo]
        then begin
             if minS<0 then minS := 0;
             if maxS>256 then maxS := 256;
        end
        else begin
             if minS<-maxSon16 then minS := -maxSon16;
             if maxS>maxSon16 then maxS := maxSon16;
        end;
}
     MediaPlayer.Close;
     saveWav(NomFichierSousEch,vecteurSonSousEch);
     MediaPlayer.Open;
     graphe.mondeY.SetMinMax(minS,maxS);
     paintBox.refresh;
end; // CalculSousEch

procedure TWaveForm.BitsCBChange(Sender: TObject);
begin
    if (graphe.pasFreq<>(FechTB.max-FechTB.position+1)) or
       (graphe.nbreBits<>BitsTB.position) then CalculSousEch
end;

procedure TWaveForm.ScrollBarChange(Sender: TObject);
begin
  TraceSelect; //efface
  graphe.debut := scrollBar.position;
  paintBox.refresh;
  debutSelect := grapheAll.Xecran(graphe.debut);
  finSelect := grapheAll.Xecran(graphe.debut+paintBox.width div pasTrace);
  TraceSelect;
end;

procedure TWaveForm.PaintBoxAllMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if NomFichier='' then exit;
   curseurT := curNormal;
   if ((finPB-debutPB)<ecartDebutFin) and
      (x>debutPB) and
      (x<finPB)
   then curseurT := curDeplace
   else if abs(x-debutPB)<precDebutFin
      then curseurT := curDebut
      else if abs(x-finPB)<precDebutFin
         then curseurT := curFin
         else if (x>debutPB) and (x<finPB)
            then curseurT := curDeplace;
   case curseurT of
       curNormal : PaintBox.Cursor := crDefault;
       curDeplace : PaintBox.Cursor := crHandPoint;
       else PaintBox.Cursor := crHsplit;
   end;
   Xdeplace := X;
end;

procedure TWaveForm.PaintBoxAllMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var dX : integer;
begin
     if NomFichier='' then exit;
     case curseurT of
         curNormal : if ((finPB-debutPB)<ecartDebutFin) and
            (x>debutPB) and (x<finPB)
            then PaintBoxAll.cursor := crHandPoint
            else if (abs(X-debutPB)<precDebutFin) or (abs(X-finPB)<precDebutFin)
               then PaintBoxAll.cursor := crHsplit
               else if (X>debutPB) and (X<finPB)
                    then PaintBox.cursor := crHandPoint
                    else PaintBox.cursor := crDefault;
         curDebut : if (X>grapheAll.limiteCourbe.left) and
                       (X<finPB) then begin
                   traceDebutFin; // efface l'ancien
                   debutPB := X;
                   traceDebutFin;
         end;
         curFin : if (X>debutPB) and
                     (X<grapheAll.limiteCourbe.right) then begin
            traceDebutFin; // efface l'ancien
            finPB := X;
            traceDebutFin;
         end;
         curDeplace : begin
            dX := X-Xdeplace;
            if ((debutPB+dX)>grapheAll.limiteCourbe.left) and
               ((finPB+dX)<grapheAll.limiteCourbe.right) then begin
                 traceDebutFin; // efface l'ancien
                 debutPB := debutPB + dX;
                 finPB := finPB + dX;
                 Xdeplace := X;
                 traceDebutFin;
             end;
         end;
     end;// case
end;

procedure TWaveForm.PaintBoxAllMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var xx,yy : extended;
begin with grapheAll do begin
      if NomFichier='' then exit;
      PaintBoxAll.Cursor := crDefault;
      traceDebutFin;
      case curseurT of
           curDebut : begin
               if X<finPB then debutPB := X;
               mondeXY(debutPB,0,xx,yy);
               debutS := round(xx);
           end;
           curFin : begin
               if X>debutPB then finPB := X;
               mondeXY(finPB,0,xx,yy);
               finS := round(xx);
           end;
           curDeplace : begin
                mondeXY(finPB,0,xx,yy);
                finS := round(xx);
                mondeXY(debutPB,0,xx,yy);
                debutS := round(xx);
           end;
      end;
      if debutS<0 then begin
           debutS := 0;
           debutPB := Xecran(debut);
      end;
      if fin>=NbrePoints then begin
           finS := pred(NbrePoints);
           finPB := Xecran(fin);
      end;
      if finS>=pred(NbrePoints)+paintBoxAll.width*pasTrace then begin
           finS := paintBoxAll.width*pasTrace-1;
           finPB := xecran(fin);
      end;
      curseurT := curNormal;
      traceDebutFin;
      affecteDebutFin;
end end;

procedure TWaveForm.PaintBoxAllPaint(Sender: TObject);
begin with grapheAll do begin
        if NomFichier='' then exit;
        rectPB := rect(0,0,paintBoxAll.width,paintBoxAll.height);
        LimiteCourbe := PaintBoxAll.ClientRect;
        inc(limiteCourbe.Left,2);
        dec(limiteCourbe.Right,2);
  // pour accder plus facilement au rglage de debut/-fin  la souris
        decalageCanvas := paintBoxAll.Top;
        drawAll;
        debutPB := Xecran(debutS);
        finPB := Xecran(finS);
        TraceDebutFin;
        TraceSelect;
end end;

procedure TWaveForm.PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Xi,Yi : extended;
begin
      if NomFichier='' then exit;
      graphe.traceRepere;
      graphe.mondeXY(X,Y,Xi,Yi);
      if ssShift in shift
         then graphe.repereTemps := round(Xi)
         else graphe.repere := round(Xi);
      graphe.traceRepere;
      Temps.update;
end;

procedure TWaveForm.StopPlayBtnClick(Sender: TObject);
begin
   MediaPlayer.notify := true;
   StopPlayBtn.enabled := false;
   MediaPlayer.stop;
end;

Procedure TWaveForm.LanceAcqGTS2;
begin
    attente := false;
    Nvoies := 1;
    Nbits := 16;
    vecteurSon.formatWave := f16;
    FreqEch := FreqEchGts2;
    vecteurSonSousEch.formatWave := f16;
    VoieSerie.onTriggerAvail := TriggerAvailBin;
    indexOctet := 0;
    NbreCourant := 0;
    Gauge.position := 0;
    attente := true;
    VoieSerie.tracing := tlon;
    VoieSerie.Open := true;
    VoieSerie.OutPut := ordreProgramme+crCR;
    VoieSerie.OutPut := ordreLance+crCR;
end;// LanceAcqGTS2

{$IFDEF GTI2}
Procedure TWaveForm.LanceAcqGTI2;
begin
    attente := false;
    Nvoies := 1;
    Nbits := 16;
    vecteurSon.formatWave := f16;
    FreqEch := FreqEchGts2;
    vecteurSonSousEch.formatWave := f16;
    indexOctet := 0;
    NbreCourant := 0;
    Gauge.position := 0;
    attente := true;
    gti2.outPut := ordreProgramme;
    gti2.OutPut := ordreLance;
    gti2.LanceThreadZresul(FreqEchGTS2*2); // 1 mot=2 octets
end;// LanceAcqGTI2
{$ENDIF}

Procedure TWaveForm.LanceAcqGTI;
begin
    attente := false;
    Nvoies := 1;
    Nbits := 16;
    vecteurSon.formatWave := f16;
    FreqEch := FreqEchGts2;
    vecteurSonSousEch.formatWave := f16;
    VoieSerie.onTriggerAvail := TriggerAvailBin;
    indexOctet := 0;
    NbreCourant := 0;
    Gauge.position := 0;
    attente := true;
    VoieSerie.Open := true;
    VoieSerie.tracing := tlon;
    VoieSerie.OutPut := ordreProgrammeGTI+crCR;
    VoieSerie.OutPut := ordreLanceGTI+crCR;
    VoieSerie.OutPut := ordreResulGTI+crCR;
end; // LanceAcqGTI

procedure TWaveForm.TriggerAvailAsc(CP: TObject; Count: Word);
var C : ansichar;
    i : integer;
begin
     C := #0;
     for i := 1 to count do begin
        if VoieSerie.CharReady
           then C := voieSerie.getChar
           else exit; // ne devrait pas arriver mais arrive ??
        if C>=' '
           then chaineLue := chaineLue+C
           else if C=crCR then inc(NlignesLues);
        finDeChaine := NlignesLues>=NLignesAlire;
     end;{ i }
end; // TriggerAvailAsc

procedure TWaveForm.TriggerAvailBin(CP: TObject; Count: Word);

procedure MajResul;
begin
     Attente := false;
     if not StopEnCours then VoieSerie.Open := false;
     if NbreCourant>2048 then begin
          NbrePoints := NbreCourant;
          Gauge.Position := NbrePoints;
          graphe.NbreTot := NbrePoints;
          scrollBar.Max := NbrePoints;
          grapheAll.NbreTot := NbrePoints;
          SaveWav(NomFichierWav,vecteurSon);
          OuvreFichier(NomFichierWav);
     end;
     RecordBtn.enabled := not StopEnCours;
     stopBtn.Enabled := false;
end;

Procedure TriggerTemps;
begin
{$IFDEF GTI2}
     if entree=eGTI2
         then valeurMot.octets[indexOctet] := gti2.getChar
         else
{$ENDIF}
        valeurMot.octets[indexOctet] := voieSerie.getChar;
        if indexOctet=0
           then indexOctet := 1
           else begin
                indexOctet := 0;
                vecteurSon.son16[NbreCourant] := valeurMot.entier;
                Gauge.Position := NbreCourant;
                inc(NbreCourant);
                if (nbreCourant>=FreqEchGTS2) or stopEnCours then MajResul;
           end; // elseif
end;

var i : integer;
begin
     for i := 1 to count do begin
        if (entree=eGTI2) or VoieSerie.CharReady { test non utile et prjudiciable ? }
           then if attente
              then triggerTemps
              else {$IFDEF GTI2}
     if entree=eGTI2
         then gti2.getChar
         else
{$ENDIF}
voieSerie.getChar
           else exit;{ ne devrait pas arriver mais arrive ? }
     end; // for i
end;

Procedure TWaveForm.TestOrphy;

Procedure testComGTI;
var Timer : EventTimer;
begin
   ChaineLue := '';
   NlignesLues := 0;
   NlignesAlire := 3;
   VoieSerie.flushInBuffer;
   FinDeChaine := false;
   VoieSerie.OutPut := 'YERR'+crCR;
   newTimer(timer,18);
   repeat
        Application.processMessages
   until finDeChaine or timerExpired(timer);
   if (pos('ORPHY',chaineLue)>0) and
      (pos('GTI',chaineLue)<>0)
         then entree := eGTI;
end;

{$IFDEF GTI2}
Procedure testGTI2;
var PosOrphy : integer;
begin
   if not GTI2.Open then exit;
   chaineLue := GTI2.Version;
   posOrphy := pos('GTI2',chaineLue);
   if posOrphy<>0
      then entree := eGTI2
      else GTI2.Close;
end;
{$ENDIF}

Procedure testCom;
var ATimer : EventTimer;
begin
   ChaineLue := '';
   NlignesLues := 0;
   NlignesAlire := 1;
   VoieSerie.flushInBuffer;
   FinDeChaine := false;
   VoieSerie.OutPut := 'WVERSION'+crCR;
   newTimer(Atimer,18);
   FinDeChaine := false;
   repeat
        Application.processMessages;
   until finDeChaine or timerExpired(Atimer);
   if pos('GTS2',chaineLue)>0 then entree := eGTS2;
end;

procedure setOrphyGTI;
begin
   ordreProgrammeGTI := 'YPEA '+intToStr(FreqEchGTS2)+' 9 0 10 A0';
    // deltat = 9*10^0*10S soit 11 111 kHz
   ordreLanceGTI := 'YGO A 0 M 0 0 0';
   OrdreResulGTI := 'YRESUL! 0 '+IntToStr(pred(FreqEchGTS2));
   VoieSerie.outPut := 'YRESET'+crcR;
   delayTicks(4,true);
   VoieSerie.outPut := 'YBAUDS 6'+crCR;
   delayTicks(2,true);
   VoieSerie.baud := 38400;
   VoieSerie.outPut := 'YBIN'+crcR;
   VoieSerie.outPut := 'YINTEGER'+crcR;
   VoieSerie.outPut := 'YCAL 0 0'+crCR; { EA0 calibre +-5 V }
end;{setGTI}

Procedure setOrphyPresent;
var posVersion : integer;
    NumeroVersionTxt : ansiString;
    tGTS : integer;
begin
   screen.cursor := crHourGlass;
   posVersion := pos('V',chaineLue);
   NumeroVersionTxt := Copy(chaineLue,posVersion+1,4);
   VoieSerie.OnTriggerAvail := TriggerAvailBin;
   VoieSerie.outPut := 'WRESET'+crcR;
   delayTicks(3,true);
   VoieSerie.outPut := 'WBAUDS 2'+crCR;
   delayTicks(3,true);
   VoieSerie.baud := 38400;
   VoieSerie.outPut := 'WBIN'+crcR;
   // deltat en s par pas de 10 s
   tGTS := trunc(1E5/FreqEchGTS2);
   deltat := tGTS*1.0E-5;
   ordreProgramme := 'WPE 1 '+
       intToStr(FreqEchGTS2)+' '+
       intToStr(tGTS*10)+' 1'+
       ' 11';
   ordreLance := 'WGOAR 127 M';
   if monocoup then ordreLance := ordreLance+' 1';
end;

{$IFDEF GTI2}
Procedure setOrphyGTI2;
var tGTS : integer;
begin
   screen.cursor := crHourGlass;
   gti2.outPut := 'WRESET';
   delayTicks(3,true);
   tGTS := trunc(1E5/FreqEchGTS2);
   deltat := tGTS*1.0E-5;
   ordreProgramme := 'WPE 1 '+
       intToStr(FreqEchGTS2)+' '+
       intToStr(tGTS*10)+' 1'+
       ' 11';
   ordreLance := 'WGOAR 127 M';
   if monocoup then ordreLance := ordreLance+' 1';
end;
{$ENDIF}

var i : integer;
begin // testOrphy
   screen.cursor := crHourGlass;
   VoieSerie.Baud := 9600;
   VoieSerie.OnTriggerAvail := triggerAvailAsc;
   for i := 1 to MaxComHandles do
       if IsPortAvailable(i) then begin
          VoieSerie.comNumber := i;
          VoieSerie.Open := true;
          testCom;
          if entree<>eGTS2 then testComGTI;
          if entree=eSon
             then VoieSerie.Open := false
             else break;
       end;
{$IFDEF GTI2}
   if gti2permis and (entree=eSon) then testGTI2;
{$ENDIF}   
   case entree of                                  
        eGTS2 : setOrphyPresent;
        eGTI : setOrphyGTI;
  {$IFDEF GTI2}
        eGTI2 : setOrphyGTI2;
  {$ENDIF}        
   end;
   Gauge.Visible := entree<>eSon;
   VoieSerie.Open := false;
   screen.cursor := crDefault;
end; // testOrphy

procedure TWaveForm.SaveWav(NomFic : string;vecteur : PvecteurSon);
var Hfichier : integer;

Procedure EnTete;

Procedure EcritTexte(texte : string);
var i,z : byte;
begin
   for i := 1 to length(texte) do begin
       z := ord(texte[i]);
       FileWrite(Hfichier,z,1)
   end
end;

Procedure EcritOctet(octet : byte);
begin
   FileWrite(Hfichier,octet,1)
end;

Procedure EcritLongMot(mot : longWord);
begin
   FileWrite(Hfichier,mot,4)
end;

Procedure EcritMot(mot : Word);
begin
   FileWrite(Hfichier,mot,2)
end;

begin
{ 0..3 }
     ecritTexte('RIFF');
{ 4..7 taille en octets poids faible en premier }
     case vecteur.formatWave of
        f8 : ecritLongMot(LongWord(NbrePoints+36));
        f16 : ecritLongMot(LongWord(NbrePoints*2+36));
        f8stereo : ecritLongMot(LongWord(NbrePoints*2+36));
        f16stereo : ecritLongMot(LongWord(NbrePoints*4+36));
     end;
{ 8..15 }
     ecritTexte('WAVEfmt ');
{ 16..19 32,16,0,0,0 }
     ecritOctet(16); { taille de la structure }
     ecritOctet(0);
     ecritOctet(0);
     ecritOctet(0);
{ 20..23 1,0,1,0 }
     ecritOctet(1); { formatTag PCM }
     ecritOctet(0);
     ecritOctet(1); { nombre de voies ? }
     ecritOctet(0);
{ 24..27 frquence poids faible en premier (en chantillons) }
     ecritLongMot(freqEch);
{ 28..31 frquence poids faible en premier (en octets) }
     case vecteur.formatWave of
          f8 : ecritLongMot(freqEch);
          f8stereo : ecritLongMot(freqEch*2);
          f16 :  ecritLongMot(freqEch*2);
          f16stereo : ecritLongMot(freqEch*4);
     end;
{ 32..33 nbre d'octets }
     case vecteur.formatWave of
        f8 : ecritOctet(1);
        f16 : ecritOctet(2);
        f8stereo : ecritOctet(2);
        f16stereo : ecritOctet(4);
     end;
     ecritOctet(0);
{ 34..35 8 ou 16 Nombre de bits }
     case vecteur.formatWave of
          f8,f8stereo : ecritOctet(8);
          f16,f16stereo : ecritOctet(16);
     end;
     ecritOctet(0);
{ 36..39 "data" }
     EcritTexte('data');
{ 40..43 nbre octets }
     case vecteur.formatWave of
        f8 : ecritLongMot(LongWord(NbrePoints));
        f16 : ecritLongMot(LongWord(NbrePoints*2));
        f8stereo : ecritLongMot(LongWord(NbrePoints*2));
        f16stereo : ecritLongMot(LongWord(NbrePoints*4));
     end;
     case vecteur.formatWave of
        f8 : FileWrite(Hfichier, vecteur.son8,NbrePoints);
        f16 : FileWrite(Hfichier, vecteur.son16,2*NbrePoints);
        f8stereo : FileWrite(Hfichier, vecteur.son8s,2*NbrePoints);
        f16stereo : FileWrite(Hfichier, vecteur.son16s,4*NbrePoints);
     end;
end;

Procedure EnTete16s;

Procedure EcritTexte(texte : string);
var i,z : byte;
begin
   for i := 1 to length(texte) do begin
       z := ord(texte[i]);
       FileWrite(Hfichier,z,1)
   end
end;

Procedure EcritOctet(octet : byte);
begin
   FileWrite(Hfichier,octet,1)
end;

Procedure EcritLongMot(mot : longWord);
begin
   FileWrite(Hfichier,mot,4)
end;

Procedure EcritMot(mot : Word);
begin
   FileWrite(Hfichier,mot,2)
end;

begin
{ 0..3 }
     ecritTexte('RIFF');
{ 4..7 taille en octets poids faible en premier }
     case vecteur.formatWave of
        f8 : ecritLongMot(LongWord(NbrePoints+50));
        f16 : ecritLongMot(LongWord(NbrePoints*2+50));
        f8stereo : ecritLongMot(LongWord(NbrePoints*2+50));
        f16stereo : ecritLongMot(LongWord(NbrePoints*4+50));
     end;
{ 8..14 }
     ecritTexte('WAVEfmt');
{ 15..19 32,18,0,0,0 }
     ecritOctet(32);
     ecritOctet(18);
     ecritOctet(0);
     ecritOctet(0);
     ecritOctet(0);
{ 20..23 1,0,2,0 }
     ecritOctet(1); { formatTag }
     ecritOctet(0);
     ecritOctet(2); { formatTag }
     ecritOctet(0);
{ 24..27 frquence poids faible en premier (en chantillons) }
     ecritLongMot(freqEch);
{ 28..31 frquence poids faible en premier (en octets) }
     case vecteur.formatWave of
          f8 : ecritLongMot(freqEch);
          f8stereo : ecritLongMot(freqEch*2);
          f16 :  ecritLongMot(freqEch*2);
          f16stereo : ecritLongMot(freqEch*4);
     end;
//     ecritMot(0);
{ 32..33 nbre d'octets }
     case vecteur.formatWave of
        f8 : ecritOctet(1);
        f16 : ecritOctet(2);
        f8stereo : ecritOctet(2);
        f16stereo : ecritOctet(4);
     end;
     ecritOctet(0);
{ 34..37 8 ou 16 Nombre de bits }
     case vecteur.formatWave of
          f8,f8stereo : ecritOctet(8);
          f16,f16stereo : ecritOctet(16);
     end;
     ecritOctet(0);
     ecritOctet(0);
     ecritOctet(0);
{ 38..41 "fact" }
     EcritTexte('fact');
{ 42..45 }
     ecritOctet(4);
     ecritOctet(0);
     ecritOctet(0);
     ecritOctet(0);
{ 46..49 nombre chantillons }
     ecritLongMot(LongWord(NbrePoints));
{ 50..53 "data" }
     EcritTexte('data');
{ 54..57 nbre octets }
     case vecteur.formatWave of
        f8 : ecritLongMot(LongWord(NbrePoints));
        f16 : ecritLongMot(LongWord(NbrePoints*2));
        f8stereo : ecritLongMot(LongWord(NbrePoints*2));
        f16stereo : ecritLongMot(LongWord(NbrePoints*4));
     end;
     case vecteur.formatWave of
        f8 : FileWrite(Hfichier, vecteur.son8,NbrePoints);
        f16 : FileWrite(Hfichier, vecteur.son16,2*NbrePoints);
        f8stereo : FileWrite(Hfichier, vecteur.son8s,2*NbrePoints);
        f16stereo : FileWrite(Hfichier, vecteur.son16s,4*NbrePoints);
     end;
end;

begin
     Hfichier := FileOpen(NomFic,fmOpenWrite);
     if HFichier>0
       then begin
         if fichierFact or (vecteur.formatWave=f16stereo)
             then EnTete16s
             else EnTete;
         FileClose(Hfichier);
         PlaySousEchBtn.Enabled := true;
         PlayBtn.Enabled := true;
         AnimBtn.enabled := true;
       end
       else ShowMessage('Impossible de sauver le fichier simul')
end;

procedure TWaveForm.OrphyBtnClick(Sender: TObject);
begin
   if entree=eSon then TestOrphy
end;

procedure TWaveForm.AideBtnClick(Sender: TObject);
begin
   Application.HelpCommand(HELP_CONTENTS, 0)
end;

procedure TWaveForm.tempsCBClick(Sender: TObject);
begin
  PaintBox.refresh
end;

procedure TWaveForm.Timer2Timer(Sender: TObject);
begin
  inc(NbreAnim);
  graphe.drawPoint(nbreAnim);
  if NbreAnim>NbreMax then begin
     timer2.enabled := false;
     AnimBtn.enabled := true;
  end;
end;

procedure TWaveForm.AnimBtnClick(Sender: TObject);
begin
     timer2.Enabled := true;
     AnimBtn.enabled := false;
     NbreAnim := 0;
     NbreMax := paintBox.width div pasTrace;
     graphe.efface;
end;

procedure TWaveForm.OptionsBtnClick(Sender: TObject);
begin
    OptionsDlg.showModal;
    paintBox.refresh;
end;

{$IFDEF GTI2}
procedure TWaveForm.WMFinZresul(var Msg: Tmessage);
begin
  gti2.stopThreadZresul(false)
end;

procedure TWaveForm.WMZresul(var Msg: Tmessage);
begin
    TriggerAvailBin(nil,msg.wparam)
end;
{$ENDIF}

procedure TWaveForm.DecodeFile(SourceFileName : String;var DestFileName : String);
var
  chan: DWORD;
  frq: Single;
  buf : array [0..10000] of BYTE;
  BytesRead : integer;
  temp : AnsiString;
  i : longint;
  RecStream : TFileStream;
  nChannels       : Word;   // number of channels (i.e. mono, stereo, etc.)
  nSamplesPerSec  : DWORD;  // sample rate
  nAvgBytesPerSec : DWORD;
  nBlockAlign     : Word;
  wBitsPerSample  : Word;   // number of bits per sample of mono data
  chaninfo: BASS_CHANNELINFO;
begin
  DestFileName:=changeFileExt(SourceFileName,'.wav');
  chan := BASS_StreamCreateFile(FALSE, PChar(SourceFileName), 0, 0, BASS_STREAM_DECODE
              or BASS_UNICODE);

  CancelOp := False;
  caption := 'Ouverture du fichier ...';

  BASS_ChannelGetInfo(chan, chaninfo);
	nChannels := chaninfo.chans;
  if (chaninfo.flags and BASS_SAMPLE_8BITS > 0)
     then wBitsPerSample := 8
     else wBitsPerSample := 16;

	nBlockAlign := nChannels * wBitsPerSample div 8;
	BASS_ChannelGetAttribute(chan, BASS_ATTRIB_FREQ, frq);
  nSamplesPerSec := Trunc(frq);
	nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;

    RecStream := TFileStream.Create(DestFileName, fmCreate);

 // Write header portion of wave file
    temp := 'RIFF'; RecStream.write(temp[1], length(temp));
    temp := #0#0#0#0; RecStream.write(temp[1], length(temp));   // File size: to be updated
    temp := 'WAVE'; RecStream.write(temp[1], length(temp));
    temp := 'fmt '; RecStream.write(temp[1], length(temp));
    temp := #$10#0#0#0; RecStream.write(temp[1], length(temp)); // Fixed
    temp := #1#0; RecStream.write(temp[1], length(temp));       // PCM format
    if nChannels = 1
       then temp := #1#0
       else temp := #2#0;
    RecStream.write(temp[1], length(temp));
    RecStream.write(nSamplesPerSec, 2);
    temp := #0#0; RecStream.write(temp[1], length(temp));   // SampleRate is given as dWord
    RecStream.write(nAvgBytesPerSec, 4);
    RecStream.write(nBlockAlign, 2);
    RecStream.write(wBitsPerSample, 2);
    temp := 'data'; RecStream.write(temp[1],length(temp));
    temp := #0#0#0#0; RecStream.write(temp[1],length(temp)); // Data size: to be updated
	while (BASS_ChannelIsActive(chan) > 0) do begin
          BytesRead := BASS_ChannelGetData(chan, @buf, 10000);
          RecStream.Write(buf, BytesRead);
          Application.ProcessMessages;
          if CancelOp then Break;
          PercentDone := Trunc(100 * (BASS_ChannelGetPosition(Chan, BASS_POS_BYTE) / BASS_ChannelGetLength(chan, BASS_POS_BYTE)));
          //ProgressBar.Position := PercentDone;
          caption := 'Conversion : ' + IntToStr(PercentDone) + '%';
  	end;
   BASS_StreamFree(chan); // free the stream

// complete WAV header
// Rewrite some fields of header
   i := RecStream.Size - 8;    // size of file
   RecStream.Position := 4;
   RecStream.write(i, 4);
   i := i - $24;               // size of data
   RecStream.Position := 40;
   RecStream.write(i, 4);
   RecStream.Free;
   caption := 'Conversion termine';
end;

procedure TWaveForm.TraceDebutFin;
begin with PaintBoxAll.Canvas do begin
      Pen.Color := clYellow;
      Brush.Color := clInfoBk;
      Pen.mode := pmNotXOR;
      Pen.width := 3;
      Rectangle(debutPB,-2,finPB,Height);
end end;

procedure TWaveForm.TraceSelect;
begin with PaintBoxAll.Canvas do begin
      Pen.Color := clBlue;
      Brush.Color := clAqua;
      Pen.mode := pmNotXOR;
      Pen.width := 1;
      Rectangle(debutSelect,-2,finSelect,Height);
end end;

procedure TWaveForm.AffecteDebutFin;
begin
//
end;

end.

