unit WavMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls, grapheU, ComCtrls, MPlayer, inifiles, dynamic_bass,
  mmsystem, clipbrd, ToolWin, ImgList, fft, math, Spin;

type
  tRGBTripleArray = array[0..maxPixelCount] of TagRGBTriple;
  pRGBTripleArray = ^tRGBTripleArray;
  TcurseurTemps = (curNormal,curDebut,curFin,curDeplace);
  TWaveForm = class(TForm)
    BoutonsPanel: TPanel;
    PaintBox: TPaintBox;
    Splitter: TSplitter;
    BoucleCB: TCheckBox;
    DureeTot: TLabel;
    StereoCB: TCheckBox;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    FreqLabel: TLabel;
    FreqRegLabel: TLabel;
    Timer1: TTimer;
    PositionLabel: TLabel;
    DureeReg: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    MediaPlayer: TMediaPlayer;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    OpenFileBtn0: TToolButton;
    SaveFileBtn: TToolButton;
    RegressiBtn: TToolButton;
    SaveDataBtn: TToolButton;
    RecordBtn: TToolButton;
    StopBtn: TToolButton;
    ModeBtn0: TToolButton;
    PlayBtn: TToolButton;
    ExitBtn0: TToolButton;
    FFTbtn: TToolButton;
    PaintBoxZoom: TPaintBox;
    SonagrammeBtn: TToolButton;
    sonagrammeCB: TComboBox;
    FreqEchDiv2Btn: TToolButton;
    EnveloppeCB: TCheckBox;
    PaintBoxFFT: TPaintBox;
    ZoomUD: TUpDown;
    Label3: TLabel;
    procedure OpenFileBtnClick(Sender: TObject);
    procedure RegressiBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxZoomPaint(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SaveFileBtnClick(Sender: TObject);
    procedure RecordBtnClick(Sender: TObject);
    procedure ModeBtnClick(Sender: TObject);
    procedure MediaPlayerNotify(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure SaveDataBtnClick(Sender: TObject);
    procedure WaveSBChange(Sender: TObject);
    procedure FFTbtnClick(Sender: TObject);
    procedure sonagrammeCBChange(Sender: TObject);
    procedure FreqEchDiv2BtnClick(Sender: TObject);
    procedure PaintBoxFFTPaint(Sender: TObject);
    procedure ZoomUDChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: SmallInt; Direction: TUpDownDirection);
  private
    graphe,grapheZoom : TgrapheSon;
    spectre : TvecteurFFT;
    curseurT : TcurseurTemps;
    debutPB,finPB,positionPB : longInt;
    Xdeplace : integer;
    NbrePoints : longInt; { 32 bits }
    FDeviceID: Word;
    FractionLue : double;
    pasReg,pasTrace : word;
    schannonOK : boolean;
    nomFichierWav : string;
    stopEnCours : boolean;
    startRecord : TdateTime;
    compteur, compteurMax :integer;
    vecteurSon : PvecteurSon;
    debut,fin : longInt;
    NomFichier : String;
    FreqReg : LongWord;
    debutFFT : integer;
    changeDF : boolean;
    bitmapCourant : Tbitmap;
   //  conversion mp3 wav
    cancelOp : boolean;
    percentdone : integer;
    bassOK : boolean;
    Procedure TraceDebutFin;
    Procedure affecteDebutFin;
    procedure OuvreFichier(Nom : String);
    procedure StopLecture(Definitif : boolean);
    Procedure TracePosition;
    procedure ChercheFreqReg;
    procedure CloseMedia;
    procedure SaveMedia;
    procedure DecodeFile(SourceFileName : String;var DestFileName : String);
  public
     FreqEch : LongWord;
     NBits : byte;
     IndexMode : byte;
     Nvoies : byte;
  protected
  end;

var
  WaveForm: TWaveForm;

implementation

uses ImageConst, imageDDE, ConstRegavi, TestInWav, ImageMain;

{$R *.DFM}

const
   crTab = #9;
   ecartDebutFin = 50;
   precDebutFin = 5;
type
   EWavError = class(Exception);

procedure TWaveForm.OpenFileBtnClick(Sender: TObject);
var extension,fichierWav : string;
begin
  if OpenDialog.execute then begin
     extension := extractFileExt(openDialog.fileName);
     extension := UpperCase(extension);
     if extension='.MP3'
        then if bassOK
           then begin
              decodeFile(openDialog.fileName,fichierWav);
              ouvrefichier(fichierWav);
           end
           else showMessage('Bass.dll non trouv')
     else ouvreFichier(openDialog.fileName);
     saveFileBtn.enabled := false;
  end;
end;

procedure TWaveForm.OuvreFichier(Nom : String);
var Hfichier : integer;

Procedure EcritFichier(stereo : boolean);
const N = 1000000;
      FreqEch = 44100;
var Hfichier2 : integer;

Procedure EcritTexte(texte : String);
var i,z : byte;
begin
   for i := 1 to length(texte) do begin
       z := ord(texte[i]);
       FileWrite(Hfichier2,z,1)
   end
end;

Procedure EcritOctet(octet : byte);
begin
   FileWrite(Hfichier2,octet,1)
end;

Procedure EcritLongMot(mot : longWord);
begin
   FileWrite(Hfichier2,mot,4)
end;

Procedure EcritMot(mot : Word);
begin
   FileWrite(Hfichier2,mot,2)
end;

var j : integer;
    octet : smallInt;
    sampleSize : integer;
    F : TextFile;
begin
     NomFichier := changeFileExt(NomFichier,'.txt');
     if not FileExists(NomFichier) then begin
        AssignFile(F,NomFichier);
        Rewrite(F);
        write(F,'RIFF');
        CloseFile(F);
     end; { un truc tordu je ne sais plus pourquoi }
     Hfichier2 := FileOpen(NomFichier,fmOpenWrite);
     if HFichier2<=0 then exit;
     if stereo then sampleSize := 4 else sampleSize := 2;
{ 0..3 riff }
     ecritTexte('RIFF');
{ 4..7 taille en octets poids faible en premier }
     ecritLongMot(LongWord(N*sampleSize+36));
{ taille de ce qui suit d'o
  +36 = 44 octets de codage - les 8 prcdents
  *sampleSize = octets par chantillon }
{ 8..15 WAVEFMT }
     ecritTexte('WAVEfmt ');
{ 16..19 16,0,0,0 : size les 16 octets qui suivent }
     ecritLongMot(16);
{ 20..23 1,0,1 ou 2,0 (4) }
     ecritMot(1); { format tag }
     if stereo then ecritMot(2) else ecritMot(1); { nombre de voies }
{ 24..27 frquence poids faible en premier en chantillons (8) }
     ecritLongMot(word(FreqEch));
{ 28..31 frquence poids faible en premier en octets (12) }
     ecritLongMot(word(FreqEch*sampleSize));
{ 32..33  block align sur sampleSize octets (14) }
{ 34..35 8 ou 16 Nombre de bits (16) }
     ecritMot(sampleSize);
     ecritMot(16);
{ 36 39 "data" }
     EcritTexte('data');
{ 40..43 nbre chantillon }
     ecritLongMot(LongWord(N*sampleSize));
     for j := 0 to pred(N) do begin
         FileRead(Hfichier,octet,2);
         FileWrite(Hfichier2,octet,2);
     end;
     FileClose(Hfichier2);
     FileClose(Hfichier);
end;

Procedure Erreur;
begin
        NomFichier := '';
        RegressiBtn.enabled := false;
        SaveDataBtn.enabled := false;
        Caption := CaptionWav;
        MediaPlayer.Notify := false;
        try
        MediaPlayer.close;
        except
        end;
        MediaPlayer.FileName := '';
end;

Procedure ErreurMediaPlayer;
begin
        MediaPlayer.Notify := false;
        try
        MediaPlayer.close;
        except
        end;
        MediaPlayer.FileName := '';
        PlayBtn.Visible := false;
end;

var i : integer;
    Nbit,Nvoie : byte;
    codeF : longWord;
    octet : byte;
    texte : ansiString;
    taille : longInt;
begin // ouvreFichier
     try
     PlayBtn.Visible := true;
     NomFichier := AnsiUpperCase(Nom);
     if not(FileExists(NomFichier)) then exit;
     Hfichier := FileOpen(NomFichier,fmOpenRead);
     if HFichier<0 then
        raise EWavError.Create('Problme d''ouverture');
// EcritFichier(false);
     FileSeek(Hfichier,4,0); // RIFF
     FileRead(Hfichier,taille,4);
// function FileSeek(Handle: Integer; Offset: Integer; Origin: Integer): Integer;
     FileSeek(Hfichier,24,0);
     FileRead(Hfichier,codeF,4);
     FreqEch := codeF;
     FileSeek(Hfichier,34,0);
     FileRead(Hfichier,Nbit,1);
     if Nbit=8
        then vecteurSon.formatWave := f8
        else if Nbit=16
             then vecteurSon.formatWave := f16
             else if Nbit=24
                 then vecteurSon.formatWave := f24
                 else begin
                    FileClose(Hfichier);
                    raise EWavError.Create(erFormatWav);
                 end;
     FreqLabel.caption := trFrequence+intToStr(FreqEch)+' Hz ; '+intToStr(Nbit)+' bits';
     FileSeek(Hfichier,22,0);
     FileRead(Hfichier,Nvoie,1);
     if Nvoie=2 then case vecteurSon.formatWave of
        f8 : vecteurSon.formatWave := f8stereo;
        f16 : vecteurSon.formatWave := f16stereo;
        f24 : vecteurSon.formatWave := f24stereo;
     end;
     FileSeek(Hfichier,36,0);
     texte := '';
     for i := 1 to 4 do begin
         FileRead(Hfichier,octet,1);
         texte := texte+ansiChar(octet);
     end;
     i := 40;
     while (i<taille) and (texte<>'data') do begin
          delete(texte,1,1);
          FileRead(Hfichier,octet,1);
          texte := texte+ansiChar(octet);
          inc(i);
     end;
     if i>=taille then begin
         FileClose(Hfichier);
         raise EWavError.Create('Format incorrect');
     end;
     FileRead(Hfichier,NbrePoints,4);
     if NbrePoints>MaxVecteurSon
        then begin
            FractionLue := NbrePoints/MaxVecteurSon;
            NbrePoints := MaxVecteurSon;
        end
        else FractionLue := 1;
     case vecteurSon.formatWave of
        f8 : NbrePoints := FileRead(Hfichier, vecteurSon.son8, NbrePoints);
        f8stereo : begin
           NbrePoints := FileRead(Hfichier, vecteurSon.son8s, NbrePoints);
           NbrePoints := NbrePoints div 2;
        end;
        f16 : begin
            NbrePoints := FileRead(Hfichier, vecteurSon.son16, NbrePoints);
            NbrePoints := NbrePoints div 2;
        end;
        f24 : begin
            NbrePoints := FileRead(Hfichier, vecteurSon.son8, NbrePoints);
            NbrePoints := NbrePoints div 3;
        end;
        f16stereo : begin
           NbrePoints := FileRead(Hfichier, vecteurSon.son16s, NbrePoints);
           NbrePoints := NbrePoints div 4;
        end;
        f24stereo : begin
            NbrePoints := FileRead(Hfichier, vecteurSon.son8s, NbrePoints);
            NbrePoints := NbrePoints div 6;
        end;
     end;
     FileClose(Hfichier);
     RegressiBtn.enabled := true;
     SaveDataBtn.enabled := true;
     StereoCB.visible := vecteurSon.formatWave in [f8stereo,f16stereo,f24stereo];
     if not StereoCB.visible then StereoCB.checked := false;
     if NbrePoints<=0 then raise EWavError.Create('');
     Caption := CaptionWav+' ['+ExtractFileName(NomFichier)+']';
     if FractionLue<1 then caption := caption + erTronque;
     debut := 0;
     fin := pred(NbrePoints);
     pasTrace := puiss2Sup(NbrePoints div PaintBox.width);
     DureeTot.caption := TrDuree+FloatToStrF(NbrePoints/FreqEch,ffFixed,5,2)+' s';
     if PlayBtn.enabled then stopLecture(true);
     try
     MediaPlayer.FileName := NomFichier;
     MediaPlayer.open;
     if not (mediaPlayer.timeFormat in [tfSamples,tfMilliSeconds]) then
        mediaPlayer.timeFormat := tfSamples;
     except
        ErreurMediaPlayer;
     end;
     AffecteDebutFin;
     PlayBtn.enabled := vecteurSon.formatWave in [f8,f8stereo,f16,f16stereo];
     except
        Erreur
     end;
     PaintBox.refresh;
     PaintBoxZoom.refresh;
     changeDF := true;
     if PaintBoxFFT.Visible then PaintBoxFFT.invalidate;
     ChercheFreqReg;
end; // ouvreFichier

procedure TWaveForm.RegressiBtnClick(Sender: TObject);
var dt : double;
    ligne : String;
    tampon : TstringList;
    nbreCourbe,c : integer;

procedure SauveEnveloppe;
var i,j,imax,pas,jdebut : integer;
    minSon,maxSon : integer;
    coeff : double;
    valeur : integer;
begin
      pas := FreqEch div 25; // 40 ms
      case vecteurSon.formatWave of
         f8,f8stereo : coeff := 1/256;
         f16,f16stereo : coeff := 1/65536;
         else coeff := 1;
      end;
      imax := (fin-debut) div pas;
      for i := 0 to pred(imax) do begin
          jdebut := debut+i*pas;
          case vecteurSon.formatWave of
             f8 : minSon := vecteurSon.son8[jdebut];
             f16 : minSon := vecteurSon.son16[jdebut];
             f8stereo : minSon := vecteurSon.son8s[jdebut,gauche];
             f16stereo : minSon := vecteurSon.son16s[jdebut,gauche];
             else minSon := 0;{ pour le compilateur ! }
          end;{case}
          maxSon := minSon;
          for j := succ(jdebut) to pred(jdebut+pas) do
      case vecteurSon.formatWave of
         f8 : if vecteurSon.son8[j]>maxSon
                  then maxSon := vecteurSon.son8[j]
                  else if vecteurSon.son8[j]<minSon
                       then minSon := vecteurSon.son8[j];
         f16 : if vecteurSon.son16[j]>maxSon
                  then maxSon := vecteurSon.son16[j]
                  else if vecteurSon.son16[j]<minSon
                       then minSon := vecteurSon.son16[j];
         f24 : begin
              valeur := graphe.valeur24bits(3*j);
              if valeur>maxSon
                  then maxSon := valeur
                  else if valeur<minSon
                       then minSon := valeur;
         end;
         f8stereo : if vecteurSon.son8s[j,gauche]>maxSon
                  then maxSon := vecteurSon.son8s[j,gauche]
                  else if vecteurSon.son8s[j,gauche]<minSon
                       then minSon := vecteurSon.son8s[j,gauche];
         f16stereo : if vecteurSon.son16s[j,gauche]>maxSon
                  then maxSon := vecteurSon.son16s[j,gauche]
                  else if vecteurSon.son16s[j,gauche]<minSon
                       then minSon := vecteurSon.son16s[j,gauche];
         f24stereo : begin
              valeur := graphe.valeur24bits(6*j);
              if valeur>maxSon
                  then maxSon := valeur
                  else if valeur<minSon
                       then minSon := valeur;
         end;
      end; // case format
      Ligne := IntToStr(i)+crTab;
      Ligne := Ligne+FloatToStrF(coeff*(maxson-minson),ffGeneral,7,1);
      tampon.add(Ligne);
      end; // j
end;// SauveEnveloppe

procedure SauveSon;
var i : integer;
begin
     for i := debut to fin do if (i mod pasReg=0) then begin
         Ligne := FloatToStrF((i-debut)*dt,ffGeneral,7,1)+crTab;
         case vecteurSon.formatWave of
             f8 : Ligne := Ligne+IntToStr(vecteurSon.son8[i]-128);
             f8stereo : begin
                 Ligne := Ligne+IntToStr(vecteurSon.son8s[i,gauche]);
                 if stereoCB.checked then Ligne := Ligne+crTab+
                         IntToStr(vecteurSon.son8s[i,droite]);
             end;
             f16 : Ligne := Ligne+IntToStr(vecteurSon.son16[i]);
             f24 : Ligne := Ligne+FloatToStrPoint(graphe.valeur24(3*i));
             f16stereo : begin
                  Ligne := Ligne+IntToStr(vecteurSon.son16s[i,gauche]);
                  if stereoCB.checked then Ligne := Ligne+crTab+
                       IntToStr(vecteurSon.son16s[i,droite]);
             end;
             f24stereo : begin
                  Ligne := Ligne+FloatToStrPoint(graphe.valeur24(6*i));
                  if stereoCB.checked then Ligne := Ligne+crTab+
                       FloatToStrPoint(graphe.valeur24(6*i+3));
             end;
         end;
         tampon.add(Ligne);
     end;
end;

const SymbReg2 : char = '&';
begin
   if (AnsiCompareFileName(NomFichier,NomFichierWav)=0) and
      (application.MessageBox('Sauvegarde prliminaire des donnes dans un fichier Wav ?','Regavi',mb_yesno)=idYes)
      then begin
          saveDialog.filter := 'Fichier son|*.wav';
          if saveDialog.Execute then begin
             mediaPlayer.FileName := saveDialog.FileName;
             mediaPlayer.save;
          end;
      end;
   if ConstanteDlg.showModal=mrOk then begin
     tampon := TstringList.create;
     Screen.Cursor := crHourGlass;
     dt := 1/FreqEch;
     tampon.add(Application.exeName);
     ChercheFreqReg;
     if ConstanteDlg.NewPageCB.itemIndex=0
        then tampon.add('Acquisition  fech='+IntToStr(round(1/pasReg/dt))+' Hz')
        else tampon.add('');
     tampon.add(ConstanteDlg.EditComm.text);
     if (vecteurSon.formatWave in [f8stereo,f16stereo,f24stereo]) and
        stereoCB.checked
        then begin
           tampon.add('t'+crTab+'sG'+crTab+'sD');
           tampon.add('s'+crTab+''+crTab+'')
        end
        else begin
          tampon.add('t'+crTab+'s');
          tampon.add('s'+crTab+'');
        end;
     if enveloppeCB.checked then SauveEnveloppe else SauveSon;
     FormDDE.AjouteConst(tampon);
     if stereoCB.checked then NbreCourbe := 2 else NbreCourbe := 1;
     tampon.Add(symbReg2+intToStr(NbreCourbe)+' NOMX');
     for c := 1 to NbreCourbe do tampon.Add('t');
     tampon.Add(symbReg2+intToStr(NbreCourbe)+' NOMY');
     if stereoCB.checked
           then begin
              tampon.Add('sG');
              tampon.Add('sD');
           end
           else tampon.Add('s');
     tampon.Add(symbReg2+intToStr(NbreCourbe)+' LIGNE');
     for c := 1 to NbreCourbe do tampon.Add('2');
     if NbreCourbe=2 then begin
        tampon.Add(symbReg2+'1 ANALOG');
        tampon.Add('1');
     end;
     if AnsiCompareFileName(mediaPlayer.FileName,NomFichierWav)<>0 then begin
        tampon.add('&1 FICHIER');
        tampon.add(mediaPlayer.FileName);
     end;
     ClipBoard.asText := tampon.text;
     FormDDE.Execute;
     ConstanteDlg.NewPageCB.itemIndex := 1;
     tampon.free;
     Screen.Cursor := crDefault;
end end;

procedure TWaveForm.ExitBtnClick(Sender: TObject);
begin
    ChangeDF := true;
    Close
end;

{
0..3 "RIFF"
4..7 taille en octets poids faible en premier
8..14 "WAVEfmt " (espace pour finir)
16 18 ou 16
17..21 0,0,0,1,0
22 1 ou 2 nombre de voies
23 0
24..27 frquence poids faible en premier
28..31 frquence double poids faible en premier seconde voie
32..33 2,0 ou 4,0
34 8 ou 16 Nombre de bits
35 0
36  37 0 0 0
36..39 "data"
40..43 nbre chantillon
?? 38..41 "fact"
?? 42..45 4 0 0 0
?? 46..49 "data"
?? 50..53 nbre chantillon
ensuite les donnes
}

procedure TWaveForm.FormCreate(Sender: TObject);
var ini : TmemInifile;
begin
    new(vecteurSon);
    graphe := TgrapheSon.create;
    graphe.canvas := PaintBox.canvas;
    graphe.son := vecteurSon;
    grapheZoom := TgrapheSon.create;
    grapheZoom.canvas := PaintBoxZoom.canvas;
    grapheZoom.son := vecteurSon;    
    NomFichierWav := ImageFormMain.tamponDir+'regavi.wav';
    NomFichier := '';
    NomIni := ImageFormMain.appDataDir+'regavi.ini';
    Ini := TMemIniFile.create(nomIni);
    FreqEch := ini.readInteger('Wav','freq',11025);
    Nbits := ini.readInteger('Wav','bits',8);
    indexMode := ini.readInteger('Wav','Mode',0);
    Ini.Free;
    BoutonsPanel.Color := clMenuBar;
    BoutonsPanel.Font.Color := clWindowText;
    BassOK := Load_BASSDLL('bass.dll');
    try
    if BassOK then
       BASS_Init(-1, 44100, Bass_unicode, Application.Handle, nil);
    except
       BassOK := false;
    end;
    bitmapCourant := TBitmap.Create;
    bitmapCourant.PixelFormat := pf24bit; // d'o triple pour scanLine
end;

procedure TWaveForm.PaintBoxPaint(Sender: TObject);
begin
if NomFichier='' then exit;
with graphe do begin
        LimiteCourbe := PaintBox.ClientRect;
        inc(limiteCourbe.Left,2);
        dec(limiteCourbe.Right,2);
  // pour accder plus facilement au rglage de debut/-fin  la souris
        debutS := 0;
        finS := pred(NbrePoints);
        drawG;
        debutPB := Xecran(debut);
        finPB := Xecran(fin);
        TraceDebutFin;
end end;

procedure TWaveForm.FormDestroy(Sender: TObject);
var ini : TmemIniFile;
begin
     bitmapCourant.Free;
     if bassOK then begin
        Bass_Free;
        Unload_BASSDLL;
     end;
     graphe.free;
     grapheZoom.free;
     dispose(vecteurSon);
     try
     Ini := TMemIniFile.create(nomIni);
     try
     Ini.WriteInteger('Wav','bits',Nbits);
     Ini.WriteInteger('Wav','freq',FreqEch);
     Ini.writeInteger('Wav','Mode',indexMode);
     Ini.upDateFile;
     finally
     Ini.Free;
     end;
     except
     end;
     waveForm := nil;
end;

procedure TWaveForm.PaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var dX : integer;
begin
     if NomFichier='' then exit;
     case curseurT of
         curNormal : if ((finPB-debutPB)<ecartDebutFin) and
            (x>debutPB) and (x<finPB)
            then PaintBox.cursor := crHandPoint
            else if (abs(X-debutPB)<precDebutFin) or (abs(X-finPB)<precDebutFin)
               then PaintBox.cursor := crHsplit
               else if (X>debutPB) and (X<finPB)
                    then PaintBox.cursor := crHandPoint
                    else PaintBox.cursor := crDefault;
         curDebut : if (X>graphe.limiteCourbe.left) and
                       (X<finPB) then begin
                   traceDebutFin; { efface l'ancien }
                   debutPB := X;
                   traceDebutFin;
         end;
         curFin : if (X>debutPB) and
                     (X<graphe.limiteCourbe.right) then begin
            traceDebutFin; { efface l'ancien }
            finPB := X;
            traceDebutFin;
         end;
         curDeplace : begin
            dX := X-Xdeplace;
            if ((debutPB+dX)>graphe.limiteCourbe.left) and
               ((finPB+dX)<graphe.limiteCourbe.right) then begin
                 traceDebutFin; { efface l'ancien }
                 debutPB := debutPB + dX;
                 finPB := finPB + dX;
                 Xdeplace := X;
                 traceDebutFin;
             end;
         end;
     end;{case}
end; // TempsMouseMove

procedure TWaveForm.PaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var xx,yy : double;
    modif : boolean;
begin with graphe do begin
      if NomFichier='' then exit;
      PaintBox.Cursor := crDefault;
      traceDebutFin;
      modif := false;
      case curseurT of
           curDebut : begin
               if X<finPB then debutPB := X;
               mondeXY(debutPB,0,xx,yy);
               debut := round(xx)+debutS;
               modif := true;
           end;
           curFin : begin
               if X>debutPB then finPB := X;
               mondeXY(finPB,0,xx,yy);
               fin := round(xx)+debutS;
               modif := true;
           end;
           curDeplace : begin
                mondeXY(finPB,0,xx,yy);
                fin := round(xx)+debutS;
                mondeXY(debutPB,0,xx,yy);
                debut := round(xx)+debutS;
                modif := true;
           end;
      end;
      if debut<debutS then begin
           debut := debutS;
           debutPB := Xecran(debut);
      end;
      if fin>=NbrePoints then begin
           fin := pred(NbrePoints);
           finPB := Xecran(fin);
      end;
      if fin>=debutS+paintBox.width*pasTrace then begin
           fin := debutS+paintBox.width*pasTrace-1;
           finPB := xecran(fin);
      end;
      curseurT := curNormal;
      traceDebutFin;
      paintBoxZoom.refresh;
      changeDF := modif;
      if sonagrammeBtn.down then paintBoxFFT.invalidate;
      affecteDebutFin;
end end;

procedure TWaveForm.TraceDebutFin;
begin with graphe,PaintBox.Canvas do begin
      Pen.Color := clTeal;
      Brush.Color := clSilver;
      Pen.mode := pmNotXOR;
      Pen.width := 3;
      Rectangle(debutPB,-2,finPB,Height);
end end;

procedure TWaveForm.PaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if NomFichier='' then exit;
   curseurT := curNormal;
   if ((finPB-debutPB)<ecartDebutFin) and
      (x>debutPB) and
      (x<finPB)
   then curseurT := curDeplace
   else if abs(x-debutPB)<precDebutFin
      then curseurT := curDebut
      else if abs(x-finPB)<precDebutFin
         then curseurT := curFin
         else if (x>debutPB) and (x<finPB)
            then curseurT := curDeplace;
   case curseurT of
       curNormal : PaintBox.Cursor := crDefault;
       curDeplace : PaintBox.Cursor := crHandPoint;
       else PaintBox.Cursor := crHsplit;
   end;
   Xdeplace := X;
end;

procedure TWaveForm.PaintBoxZoomPaint(Sender: TObject);
begin with grapheZoom do begin
        if NomFichier='' then exit;
        LimiteCourbe := PaintBoxZoom.ClientRect;
        debutS := debut;
        finS := fin;
        pasS := succ((finS-debutS) div MaxVecteur);
        canvas.Pen.Color := clBlack;
        canvas.Pen.width := 2;
        canvas.Pen.mode := pmCopy;
        canvas.Rectangle(limiteCourbe);
        drawG;
        curseurT := curNormal;
end end;

procedure TWaveForm.AffecteDebutFin;

Function GetPos(posInt : integer) : LongInt;
begin
   if mediaPlayer.timeFormat=tfMilliseconds
      then result := round(posInt*1000.0/FreqEch)
      else result := posInt;
end;

begin
   if not PlayBtn.visible then exit;
   MediaPlayer.StartPos := getPos(debut);
   MediaPlayer.EndPos := getPos(fin);
   DureeReg.caption := TrDuree+FloatToStrF((fin-debut)/FreqEch,ffFixed,5,2)+' s';
   ChercheFreqReg;
end;

procedure TWaveForm.FormDeactivate(Sender: TObject);
begin
     try
     if MediaPlayer.FileName<>'' then MediaPlayer.close
     except
     end;
end;

procedure TWaveForm.FormActivate(Sender: TObject);
begin
    if (MediaPlayer.FileName<>'') and PlayBtn.Visible then MediaPlayer.open
end;

procedure TWaveForm.FormResize(Sender: TObject);
begin
     Splitter.top := height div 2;
     if PaintBoxFFT.visible then PaintBoxFFT.height := height div 3;
end;

procedure TWaveForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     if NomFichier<>'' then stopLecture(true);
     ImageFormMain.mode := mNone;
     inherited;
end;

procedure TWaveForm.StopLecture(definitif : boolean);
begin
   try
        timer1.Enabled := false;
        MediaPlayer.Notify := false;
        MediaPlayer.Stop;
        MediaPlayer.Notify := false;
        PositionLabel.visible := false;
        StopBtn.enabled := false;
        RecordBtn.enabled := true;
        if definitif then MediaPlayer.Close;
   except
   end;
end;

procedure TWaveForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var P : Tpoint;
begin
     GetCursorPos(P);
     case key of
          vk_left : dec(P.X);
          vk_right : inc(P.X);
          vk_down : inc(P.Y);
          vk_up : dec(P.Y);
          vk_prior : if ssShift in shift
              then dec(P.X,10)
              else dec(P.Y,10);
          vk_next : if ssShift in shift
              then inc(P.X,10)
              else inc(P.Y,10);
          vk_delete : ;
          else exit;
     end;
     setCursorPos(P.X,P.Y);
end;

procedure TWaveForm.SaveFileBtnClick(Sender: TObject);
begin
    saveDialog.filter := 'Fichier son|*.wav';
    if saveDialog.Execute then begin
        mediaPlayer.FileName := saveDialog.FileName;
        mediaPlayer.save;
        saveFileBtn.enabled := false;
    end
end;

procedure TWaveForm.CloseMedia;
var
    MyGenParms: TMCI_Generic_Parms;
    MyError,Flags : LongInt;
begin
    if FDeviceID <> 0 then begin
      Flags:=0;
      MyGenParms.dwCallback:=Handle; // Form
      MyError:=mciSendCommand(FDeviceID,mci_Close,Flags,LongWord(@MyGenParms));
      if MyError = 0 then FDeviceID:=0;
    end;
end;

procedure TWaveForm.RecordBtnClick(sender : Tobject);

procedure OpenMedia;
var
    MyOpenParms: TMCI_Open_Parms;
    MyWaveParms : TMCI_WAVE_SET_PARMS;
    Flags : longWord;
    MyError : LongInt;
begin
    Flags:=mci_Wait or mci_Open_Element or mci_Open_Type;
    with MyOpenParms do  begin
      dwCallback:=Handle; // Form
      lpstrDeviceType:=PChar('WaveAudio');
      lpstrElementName:=PChar('');
    end;
    MyError:=mciSendCommand(0,mci_Open,Flags,LongWord(@MyOpenParms));
    if MyError = 0 then FDeviceID:=MyOpenParms.wDeviceID;
    with MyWaveParms do begin
          dwCallback := handle;
          nChannels := 1;
          nSamplesPerSec := freqEch;
          nAvgBytesPerSec := freqEch*Nbits div 8;
          nBlockAlign := Nbits div 8;
          wBitsPerSample := Nbits;
    end;
    Flags := MCI_WAIT or
             MCI_WAVE_SET_BITSPERSAMPLE or
             MCI_WAVE_SET_CHANNELS or
             MCI_WAVE_SET_SAMPLESPERSEC or
             MCI_WAVE_SET_AVGBYTESPERSEC or
             MCI_WAVE_SET_BLOCKALIGN;
    mciSendCommand(FdeviceId, MCI_SET,Flags,longWord(@MyWaveParms));
end;

procedure RecordMedia;
var
    MyRecordParms: TMCI_Record_Parms;
    Flags : LongInt;
begin
    Flags:=mci_Notify;
    with MyRecordParms do  begin
        dwCallback:=Handle;  // Form
        dwFrom:=0;
        dwTo:=0;
    end;
    try
    mciSendCommand(FDeviceID,mci_Record,Flags,LongWord(@MyRecordParms));
    except;
        CloseMedia;
    end;
end;

(*
procedure StopMedia;
var
    MyGenParms: TMCI_Generic_Parms;
    Flags : LongInt;
begin
  if FDeviceID <> 0 then  begin
      Flags:=mci_Wait;
      MyGenParms.dwCallback:=Handle;  // Form
      try
      mciSendCommand(FDeviceID,mci_Stop,Flags,LongWord(@MyGenParms));
      except
          CloseMedia;
      end;
    end;
end;
*)

begin
          NomFichier := '';
          MediaPlayer.Notify := false;
          try
          if MediaPlayer.FileName<>'' then MediaPlayer.close;
          except
          end;
          PlayBtn.enabled := false;
          StopBtn.enabled := true;
          RecordBtn.enabled := false;
          OpenMedia;
          RecordMedia;
          startRecord := now;
end; // record

procedure TWaveForm.ModeBtnClick(Sender: TObject);
begin
   TestWavDlg := TtestWavDlg.create(self);
   TestWavDlg.showModal;
   TestWavDlg.free;
end;

procedure TWaveForm.MediaPlayerNotify(Sender: TObject);
begin
  if boucleCB.checked
     then begin
         AffecteDebutFin;
         mediaPlayer.notify := true;
         mediaPlayer.play;
     end
     else begin
         PlayBtn.enabled := true;
         StopBtn.enabled := false;
         RecordBtn.enabled := true;
         Timer1.enabled := false;
         PositionLabel.visible := false;
         TracePosition;
     end;
end;

procedure TWaveForm.PlayBtnClick(Sender: TObject);
var duree : double;
begin
  AffecteDebutFin;
  Duree := (fin-debut)/FreqEch;
  Timer1.Enabled := Duree>0.55;
  PositionLabel.visible := true;
  PositionPB := debutPB;
  TracePosition;
  PlayBtn.enabled := false;
  StopBtn.enabled := true;
  RecordBtn.enabled := false;
  MediaPlayer.notify := true;
  MediaPlayer.Play;
end;

procedure TWaveForm.Timer1Timer(Sender: TObject);
var posSec : double;
begin
    if StopEnCours then begin
       inc(compteur);
       if compteur>compteurMax then begin
          stopEnCours := false;
          stopBtn.enabled := false;
          recordBtn.enabled := true;
          Timer1.enabled := false;
          if PaintBoxFFT.Visible and fftBtn.down then
             paintBoxFFT.canvas.Rectangle(PaintBoxFFT.ClientRect);
          saveMedia;
        end;
        exit;
    end;
    if MediaPlayer.FileName<>'' then begin
         TracePosition; { efface }
         if mediaPlayer.timeFormat=tfMilliseconds
            then PosSec := mediaPlayer.position/1000.0
            else PosSec := mediaPlayer.position/FreqEch;
         positionPB := graphe.Xecran(posSec*FreqEch);
         PositionLabel.Caption := FloatToStrF(PosSec,ffFixed,5,1)+' s';
         TracePosition; { retrace }
         if fftBtn.Down then paintBoxFFT.invalidate
    end;
end;

procedure TWaveForm.FreqEchDiv2BtnClick(Sender: TObject);
var i : integer;
begin
        NbrePoints := NbrePoints div 2;
        graphe.debutS := graphe.debutS div 2;
        graphe.finS := graphe.finS div 2;
        debut := debut div 2;
        fin := fin div 2;
        FreqEch := FreqEch div 2;
        FreqLabel.caption := trFrequence+intToStr(FreqEch)+' Hz';
        case vecteurson.formatWave of
         f8 : for i := 0 to pred(NbrePoints) do
            vecteurson.son8[i] := vecteurson.son8[i*2];
         f16 : for i := 0 to pred(NbrePoints) do
            vecteurson.son16[i] := vecteurson.son16[i*2];
         f8stereo : for i := 0 to pred(NbrePoints) do begin
            vecteurson.son8s[i,gauche] := vecteurson.son8s[i*2,gauche];
            vecteurson.son8s[i,droite] := vecteurson.son8s[i*2,droite];
         end;
         f16stereo : for i := 0 to pred(NbrePoints) do begin
            vecteurson.son8s[i,gauche] := vecteurson.son16s[i*2,gauche];
            vecteurson.son8s[i,droite] := vecteurson.son8s[i*2,droite];
         end;
      end; // case
      PaintBox.refresh;
      PaintBoxZoom.refresh;
      changeDF := true;
      if PaintBoxFFT.visible then PaintBoxFFT.invalidate;
end;

procedure TWaveForm.TracePosition;
begin
with paintBox.canvas do begin
         pen.mode := pmNotXor;
         pen.color := clRed;
         pen.Width := 1;
         moveTo(positionPB,0);
         lineTo(positionPB,paintBox.height);
end;
if sonagrammeBtn.down then with paintBoxFFT.canvas do begin
         pen.mode := pmNotXor;
         pen.color := clRed;
         pen.Width := 1;
         moveTo(positionPB,0);
         lineTo(positionPB,paintBoxFFT.height);
end;
end;

Procedure TWaveForm.ChercheFreqReg;
begin
   { 44.100 kHz Qualit CD
     22.050 kHz taux d'chantillonnage habituel Windows
     11.025 kHz lecture Windows
     8 12 16 24 32 48 kHz }
   pasReg := succ((fin-debut) div MaxVecteur);
   FreqReg := FreqEch div pasReg;
   if (FreqEch=44100) or
      (FreqEch=22050) or
      (FreqEch=11025) then begin
         SchannonOK :=
           (FreqReg=44100) or
           (FreqReg=22050) or
           (FreqReg=11025);
         if not SchannonOK and (FreqReg>11025) then begin { 44100/3 ? }
             FreqReg := 11025;
             pasReg := FreqEch div FreqReg;
             SchannonOK := true;
         end;
   end;
   if (FreqEch=8000) or (FreqEch=12000) or
      (FreqEch=16000) or (FreqEch=24000) or
      (FreqEch=32000) or (FreqEch=48000) then begin
          SchannonOK :=
            (FreqReg=8000) or (FreqReg=12000) or (FreqReg=16000) or
            (FreqReg=24000) or (FreqReg=32000) or (FreqEch=48000);
         if not SchannonOK and (FreqReg>8000) then begin { pasReg=3 par ex. }
             FreqReg := 8000;
             pasReg := FreqEch div FreqReg;
             SchannonOK := true;
         end;
   end;
   FreqRegLabel.caption := trFrequence+intToStr(FreqReg)+' Hz';
   if not SchannonOK
      then FreqRegLabel.caption := FreqRegLabel.caption + ' ?!'
end;


procedure TWaveForm.ZoomUDChangingEx(Sender: TObject; var AllowChange: Boolean;
  NewValue: SmallInt; Direction: TUpDownDirection);
var centre,largeur : longInt;
begin
  inherited;
  centre := (debut+fin) div 2;
  largeur := fin-debut;
  case direction of
       updNone : exit;
       updUp : begin
           allowChange := (debut>0) and (fin<pred(NbrePoints));
           if allowChange then begin
              largeur := puiss2Sup(largeur);
              debut := centre-largeur;
              if debut<0 then debut := 0;
              fin := centre+largeur;
              if fin>pred(NbrePoints) then fin := pred(NbrePoints);
           end
           else exit;
       end;
       updDown : begin
           allowChange := largeur>512;
           if AllowChange then begin
              largeur := puiss2Inf(largeur);
              largeur := largeur div 4;
              debut := centre-largeur;
              fin := centre+largeur;
           end
           else exit;
       end;
  end;
  paintBox.refresh;
  paintBoxZoom.refresh;
  changeDF := true;
  if sonagrammeBtn.down then paintBoxFFT.invalidate;
  affecteDebutFin;
end;

procedure TWaveForm.SaveMedia;
type    // not implemented by Delphi
    TMCI_Save_Parms = record
      dwCallback: DWord;
      lpstrFileName: PChar;  // name of file to save
    end;
var
    MySaveParms: TMCI_Save_Parms;
    Flags : LongInt;
begin
    if FDeviceID <> 0 then  begin
        // save the file...
      Cursor := crDefault;
      Flags:=mci_Save_File or mci_Wait;
      with MySaveParms do begin
          dwCallback:=Handle;
          lpstrFileName:=PChar(NomFichierWav);
      end;
      try
      mciSendCommand(FDeviceID,mci_Save,Flags,LongWord(@MySaveParms));
      saveFileBtn.enabled := true;
      closeMedia;
      OuvreFichier(NomFichierWav);
      except
      end;
    end;
end;

procedure TWaveForm.StopBtnClick(Sender: TObject);
var h,m,s,ms : word;
    dureeSec : double;
begin
   if nomFichier='' then begin // stop enregistrement
      Cursor := crHourGlass;
      StopBtn.enabled := false;
      RecordBtn.enabled := false;
      stopEnCours := true;
      decodeTime(now-startRecord,h,m,s,ms);
      DureeSec := m*60.0+s*1.0+ms*0.001;
      CompteurMax := round((1000*DureeSec-trunc(dureeSec))/Timer1.interval)+1;
// On attend la seconde entire qui est l'unit d'enregistrement
      Compteur := 0;
      Timer1.enabled := true;
   end
   else stopLecture(false)
end;

procedure TWaveForm.SaveDataBtnClick(Sender: TObject);
var fichier : TextFile;

procedure SauveSon;
var i : integer;
    dt : double;
begin
     dt := 1/FreqEch;
     for i := debut to fin do begin
         write(fichier,FloatToStrF((i-debut)*dt,ffGeneral,7,1)+crTab);
         case vecteurSon.formatWave of
             f8 : writeln(fichier,IntToStr(vecteurSon.son8[i]-128));
             f8stereo : begin
                 write(fichier,IntToStr(vecteurSon.son8s[i,gauche]-128));
                 if stereoCB.checked
                    then writeln(fichier,crTab+IntToStr(vecteurSon.son8s[i,droite]-128))
                    else writeln(fichier);
             end;
             f16 : writeln(fichier,IntToStr(vecteurSon.son16[i]));
             f16stereo : begin
                  write(fichier,IntToStr(vecteurSon.son16s[i,gauche]));
                  if stereoCB.checked
                     then writeln(fichier,crTab+IntToStr(vecteurSon.son16s[i,droite]))
                     else writeln(fichier)
             end;
         end;
     end;
end;

begin
   saveDialog.filter := 'Fichier texte|*.txt';
   if saveDialog.Execute then begin
     assignFile(Fichier,saveDialog.FileName);
     rewrite(fichier);
     if (vecteurSon.formatWave in [f8stereo,f16stereo,f24stereo]) and
        stereoCB.checked
        then begin
           writeln(fichier,'t'+crTab+'sonGauche'+crTab+'sonDroit');
           writeln(fichier,'s'+crTab+''+crTab+'')
        end
        else begin
          writeln(fichier,'t'+crTab+'son');
          writeln(fichier,'s'+crTab+'');
        end;
     SauveSon;
     closeFile(fichier);
end end;

{
 FreqLabel.caption := trFrequence+intToStr(FreqEch)+' Hz ; '+intToStr(Nbit)+' bits';
 DureeTot.caption := TrDuree+FloatToStrF(NbrePoints/FreqEch,ffFixed,5,2)+' s';
 DureeReg.caption := TrDuree+FloatToStrF((fin-debut)/FreqEch,ffFixed,5,2)+' s';
 if SchannonOK
    then FreqRegLabel.caption := trFrequence+intToStr(FreqReg)+' Hz'
    else FreqRegLabel.caption := trFrequence+'? (Schannon !)';
}
     
procedure TWaveForm.WaveSBChange(Sender: TObject);
begin
  PaintBox.invalidate
end;

procedure TWaveForm.FFTbtnClick(Sender: TObject);
begin
  inherited;
  PaintBoxFFT.Visible := FFTbtn.down or sonagrammeBtn.down;
  PaintBoxFFT.height := height div 3;
  sonagrammeCB.visible := sonagrammeBtn.down;
  changeDF := true;
  PaintBoxFFT.invalidate;
end;

procedure TWaveForm.PaintBoxFFTPaint(sender:TObject);

Procedure TraceFFT;
var ax,ay : double;
    maxiFFT : double;
    xi,yi,p : integer;
    i : integer;
    posSec : double;
    deltaF : integer;
    Xmax : integer;
begin with paintBoxFFT.canvas do begin
            if mediaPlayer.timeFormat=tfMilliseconds
                then PosSec := mediaPlayer.position/1000.0
                else PosSec := mediaPlayer.position/FreqEch;
            debutFFT := round(posSec*FreqEch)-(maxVecteurFFT div 2);
            if debutFFT<0 then debutFFT := 0;
            if debutFFT+maxVecteurFFT>=nbrePoints then
               debutFFT := NbrePoints-maxVecteurFFT-1;
            Fourier(DebutFFT,debutFFT+maxVecteurFFT,vecteurSon,spectre,MaxiFFT);
            if FreqEch>20000
               then Xmax := NbreF*20000 div FreqEch
               else Xmax := NbreF;
       // Frquence max 10 kHz
            ay := paintBoxFFT.height/maxiFFT;
            ax := paintBoxFFT.width/Xmax;
            brush.Color := clWindow;
            brush.style := bsSolid;
            pen.Color := clActiveCaption;
            pen.style := psSolid;
            Rectangle(PaintBoxFFT.ClientRect);
            for i := 0 to pred(Xmax) do begin
                xi := round(ax*i);
                yi := paintBoxFFT.height-round(ay*spectre[i]);
                moveto(xi,paintBoxFFT.height);
                lineto(xi,yi);
            end;
            if FreqEch>20000
               then begin
                 deltaF := 20000 div 10 div 2;
                 ax := 2*paintBoxFFT.width/20000;
               end
               else begin
                  deltaF := freqEch div 10 div 2; // 10 graduations ; /2 = Schannon
                  ax := 2*paintBoxFFT.width/FreqEch;
               end;
            p := round(power(10,trunc(log10(deltaF))));
            if p>=deltaF
               then deltaF := p
               else if 2*p>=deltaF
                    then deltaF := 2*p
                    else if 5*p>=deltaF
                       then deltaF := 5*p
                       else deltaF := 10*p;
            i := 1;
            pen.Color := clHotLight;
            font.Color := clHotLight;
            pen.style := psDot;
            repeat
                 xi := round(ax*i*deltaF);
                 moveto(xi,paintBoxFFT.height);
                 lineto(xi,0);
                 textOut(xi-16,paintBoxFFT.height div 10,intToStr(i*deltaF)+' Hz');
                 inc(i);
            until xi>paintBoxFFT.width;
end end;

procedure TraceSonagramme;
var col,pasCol,Ligne,yM : integer;
    x1, x2,xB : integer;
    IntReal : double;
    deltaY : double;
    YsonMax,ligneMax,Xmax : integer;
    scanLine : pRGBtripleArray;
    A,B : double;
    couleur : Trgbtriple;
    label finTrace;
begin
    if changeDF then begin
       Sonagramme.calcul(debut,fin,vecteurSon);
       changeDF := false;
    end;
    BitmapCourant.width := PaintBoxFFT.Width;
    BitmapCourant.height := 1;
    ligneMax := PaintBoxFFT.Height;
    xmax := PaintBoxFFT.Width-1;
    A := grapheZoom.mondeX.A;
    B := grapheZoom.mondeX.B;
    x1 := 0;
    if FreqEch>20000
       then YsonMax := NbreFsonagramme*20000 div FreqEch
       else YsonMax := NbreFsonagramme;
       // Frquence max 10 kHz
    deltaY := paintBoxFFT.height/YsonMax;
    Ligne := 0;
    pasCol := floor(sonagramme.NbreSonagramme/Xmax);
    if pascol<1 then pascol := 1;
    scanLine := bitmapCourant.scanLine[0];
    while ligne<ligneMax do begin
        yM := round((ligneMax-Ligne)/deltaY);
        col := 0;
        while col<sonagramme.NbreSonagramme do begin
            x2 := round(A*col*pasSonagramme+B);
            if x2>xMax then x2 := xMax;
            IntReal := sonagramme.matriceSon[col, yM]; // entre 0 et 1
            if sonagramme.DecadeDB > 0 then begin // logarithmique sur x dcades
              try
                 IntReal := 1 + (log10(IntReal)/sonagramme.DecadeDB);
                 if IntReal < 0 then intReal := 0;
              except
                 IntReal := 0;
              end;
            end;
            couleur := GetFausseCouleur(IntReal);
            for xB := x1 to x2 do scanline[xB] := couleur;
            x1 := x2+1;
            inc(col,pasCol);
        end; // col
        PaintBoxFFT.canvas.draw(0,ligne,BitmapCourant);
        inc(ligne);
      end; // ligne
      finTrace :
end;

begin
  if MediaPlayer.FileName='' then exit;
  paintBoxFFT.OnPaint := nil; // rentrance ??
  if FFTbtn.down then if timer1.Enabled
     then traceFFT
     else begin
     paintBoxFFT.canvas.Rectangle(PaintBoxFFT.ClientRect);
     PaintBoxFFT.Canvas.Font.color := clRed;
     PaintBoxFFT.Canvas.Font.size := 10;
     PaintBoxFFT.Canvas.TextOut(PaintBoxFFT.Width div 3,
                                PaintBoxFFT.Height div 2,
                                'Cliquer sur "Jouer"');
  end;
  if sonagrammeBtn.down then traceSonagramme;
  paintBoxFFT.OnPaint := paintBoxFFTpaint;
end;

procedure TWaveForm.sonagrammeCBChange(Sender: TObject);
begin
  inherited;
  case sonagrammeCB.itemIndex of
       0 : sonagramme.decadedB := 0;
       1 : sonagramme.decadedB := 2;
       2 : sonagramme.decadedB := 3;
  end;
  paintBoxFFT.invalidate;
end;

procedure TWaveForm.DecodeFile(SourceFileName : String;var DestFileName : String);
var
  chan: DWORD;
  frq: Single;
  buf : array [0..10000] of BYTE;
  BytesRead : integer;
  temp : AnsiString;
  i : longint;
  RecStream : TFileStream;
  nChannels       : Word;   // number of channels (i.e. mono, stereo, etc.)
  nSamplesPerSec  : DWORD;  // sample rate
  nAvgBytesPerSec : DWORD;
  nBlockAlign     : Word;
  wBitsPerSample  : Word;   // number of bits per sample of mono data
  chaninfo: BASS_CHANNELINFO;
begin
  DestFileName:=changeFileExt(SourceFileName,'.wav');
  chan := BASS_StreamCreateFile(FALSE, PChar(SourceFileName), 0, 0, BASS_STREAM_DECODE
              or BASS_UNICODE);

  CancelOp := False;
  caption := 'Ouverture du fichier ...';

  BASS_ChannelGetInfo(chan, chaninfo);
	nChannels := chaninfo.chans;
  if (chaninfo.flags and BASS_SAMPLE_8BITS > 0)
     then wBitsPerSample := 8
     else wBitsPerSample := 16;

	nBlockAlign := nChannels * wBitsPerSample div 8;
	BASS_ChannelGetAttribute(chan, BASS_ATTRIB_FREQ, frq);
  nSamplesPerSec := Trunc(frq);
	nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;

    RecStream := TFileStream.Create(DestFileName, fmCreate);

 // Write header portion of wave file
    temp := 'RIFF'; RecStream.write(temp[1], length(temp));
    temp := #0#0#0#0; RecStream.write(temp[1], length(temp));   // File size: to be updated
    temp := 'WAVE'; RecStream.write(temp[1], length(temp));
    temp := 'fmt '; RecStream.write(temp[1], length(temp));
    temp := #$10#0#0#0; RecStream.write(temp[1], length(temp)); // Fixed
    temp := #1#0; RecStream.write(temp[1], length(temp));       // PCM format
    if nChannels = 1
       then temp := #1#0
       else temp := #2#0;
    RecStream.write(temp[1], length(temp));
    RecStream.write(nSamplesPerSec, 2);
    temp := #0#0; RecStream.write(temp[1], length(temp));   // SampleRate is given as dWord
    RecStream.write(nAvgBytesPerSec, 4);
    RecStream.write(nBlockAlign, 2);
    RecStream.write(wBitsPerSample, 2);
    temp := 'data'; RecStream.write(temp[1],length(temp));
    temp := #0#0#0#0; RecStream.write(temp[1],length(temp)); // Data size: to be updated
	while (BASS_ChannelIsActive(chan) > 0) do begin
          BytesRead := BASS_ChannelGetData(chan, @buf, 10000);
          RecStream.Write(buf, BytesRead);
          Application.ProcessMessages;
          if CancelOp then Break;
          PercentDone := Trunc(100 * (BASS_ChannelGetPosition(Chan, BASS_POS_BYTE) / BASS_ChannelGetLength(chan, BASS_POS_BYTE)));
          //ProgressBar.Position := PercentDone;
          caption := 'Conversion : ' + IntToStr(PercentDone) + '%';
  	end;
   BASS_StreamFree(chan); // free the stream

// complete WAV header
// Rewrite some fields of header
   i := RecStream.Size - 8;    // size of file
   RecStream.Position := 4;
   RecStream.write(i, 4);
   i := i - $24;               // size of data
   RecStream.Position := 40;
   RecStream.write(i, 4);
   RecStream.Free;
   caption := 'Conversion termine';
end;

end.

// MCI_ALL_DEVICE_ID.

